(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@ngrx/store'), require('@angular/fire'), require('@ionic/angular'), require('@ionic-native/facebook/ngx'), require('@ionic-native/google-plus/ngx'), require('firebase/app'), require('firebase/auth'), require('@angular/core'), require('@ngrx/effects'), require('@angular/fire/auth'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@xtream/ionic-firebase-ngrx-user-management', ['exports', '@ngrx/store', '@angular/fire', '@ionic/angular', '@ionic-native/facebook/ngx', '@ionic-native/google-plus/ngx', 'firebase/app', 'firebase/auth', '@angular/core', '@ngrx/effects', '@angular/fire/auth', 'rxjs', 'rxjs/operators'], factory) :
    (factory((global.xtream = global.xtream || {}, global.xtream['ionic-firebase-ngrx-user-management'] = {}),global.store,global.ng.fire,global.angular,global.ngx,global.ngx$1,global.firebase,null,global.ng.core,global.effects,global.ng.fire.auth,global.rxjs,global.rxjs.operators));
}(this, (function (exports,store,fire,angular,ngx,ngx$1,firebase,auth,i0,effects,auth$1,rxjs,operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var User = /** @class */ (function () {
        function User(uid, displayName, email, phoneNumber, photoURL, emailVerified) {
            this.uid = uid;
            this.displayName = displayName;
            this.email = email;
            this.phoneNumber = phoneNumber;
            this.photoURL = photoURL;
            this.emailVerified = emailVerified;
        }
        return User;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var CustomEmailHandlerActionTypes = {
        CheckActionCode: '[Auth/CustomEmailHandler] Check Action Code',
        CheckActionCodeError: '[Auth/CustomEmailHandler] Check Action Code Error',
        CheckActionCodeSuccess: '[Auth/CustomEmailHandler] Check Action Code Success',
        RecoverEmail: '[Auth/CustomEmailHandler] Recover Email',
        RecoverEmailSuccess: '[Auth/CustomEmailHandler] Recover Email Success',
        RecoverEmailError: '[Auth/CustomEmailHandler] Recover Email Error',
        ResetPassword: '[Auth/CustomEmailHandler] Reset Password',
        ResetPasswordSuccess: '[Auth/CustomEmailHandler] Reset Password Success',
        ResetPasswordError: '[Auth/CustomEmailHandler] Reset Password Error',
        VerifyEmailAddress: '[Auth/CustomEmailHandler] Verify Email Address',
        VerifyEmailAddressSuccess: '[Auth/CustomEmailHandler] Verify Email Address Success',
        VerifyEmailAddressError: '[Auth/CustomEmailHandler] Verify Email Address Error',
        VerifyPasswordResetCode: '[Auth/CustomEmailHandler] Verify Password Reset Code',
        VerifyPasswordResetCodeError: '[Auth/CustomEmailHandler] Verify Password Reset Error',
        VerifyPasswordResetCodeSuccess: '[Auth/CustomEmailHandler] Verify Password Reset Success',
    };
    var CheckActionCode = /** @class */ (function () {
        function CheckActionCode(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.CheckActionCode;
        }
        return CheckActionCode;
    }());
    var CheckActionCodeError = /** @class */ (function () {
        function CheckActionCodeError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.CheckActionCodeError;
        }
        return CheckActionCodeError;
    }());
    var CheckActionCodeSuccess = /** @class */ (function () {
        function CheckActionCodeSuccess(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.CheckActionCodeSuccess;
        }
        return CheckActionCodeSuccess;
    }());
    var RecoverEmail = /** @class */ (function () {
        function RecoverEmail(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.RecoverEmail;
        }
        return RecoverEmail;
    }());
    var RecoverEmailError = /** @class */ (function () {
        function RecoverEmailError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.RecoverEmailError;
        }
        return RecoverEmailError;
    }());
    var RecoverEmailSuccess = /** @class */ (function () {
        function RecoverEmailSuccess() {
            this.type = CustomEmailHandlerActionTypes.RecoverEmailSuccess;
        }
        return RecoverEmailSuccess;
    }());
    var ResetPassword = /** @class */ (function () {
        function ResetPassword(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.ResetPassword;
        }
        return ResetPassword;
    }());
    var ResetPasswordError = /** @class */ (function () {
        function ResetPasswordError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.ResetPasswordError;
        }
        return ResetPasswordError;
    }());
    var ResetPasswordSuccess = /** @class */ (function () {
        function ResetPasswordSuccess() {
            this.type = CustomEmailHandlerActionTypes.ResetPasswordSuccess;
        }
        return ResetPasswordSuccess;
    }());
    var VerifyEmailAddress = /** @class */ (function () {
        function VerifyEmailAddress(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyEmailAddress;
        }
        return VerifyEmailAddress;
    }());
    var VerifyEmailAddressError = /** @class */ (function () {
        function VerifyEmailAddressError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyEmailAddressError;
        }
        return VerifyEmailAddressError;
    }());
    var VerifyEmailAddressSuccess = /** @class */ (function () {
        function VerifyEmailAddressSuccess() {
            this.type = CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess;
        }
        return VerifyEmailAddressSuccess;
    }());
    var VerifyPasswordResetCode = /** @class */ (function () {
        function VerifyPasswordResetCode(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCode;
        }
        return VerifyPasswordResetCode;
    }());
    var VerifyPasswordResetCodeError = /** @class */ (function () {
        function VerifyPasswordResetCodeError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeError;
        }
        return VerifyPasswordResetCodeError;
    }());
    var VerifyPasswordResetCodeSuccess = /** @class */ (function () {
        function VerifyPasswordResetCodeSuccess(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeSuccess;
        }
        return VerifyPasswordResetCodeSuccess;
    }());

    var customEmailHandler_actions = /*#__PURE__*/Object.freeze({
        CustomEmailHandlerActionTypes: CustomEmailHandlerActionTypes,
        CheckActionCode: CheckActionCode,
        CheckActionCodeError: CheckActionCodeError,
        CheckActionCodeSuccess: CheckActionCodeSuccess,
        RecoverEmail: RecoverEmail,
        RecoverEmailError: RecoverEmailError,
        RecoverEmailSuccess: RecoverEmailSuccess,
        ResetPassword: ResetPassword,
        ResetPasswordError: ResetPasswordError,
        ResetPasswordSuccess: ResetPasswordSuccess,
        VerifyEmailAddress: VerifyEmailAddress,
        VerifyEmailAddressError: VerifyEmailAddressError,
        VerifyEmailAddressSuccess: VerifyEmailAddressSuccess,
        VerifyPasswordResetCode: VerifyPasswordResetCode,
        VerifyPasswordResetCodeError: VerifyPasswordResetCodeError,
        VerifyPasswordResetCodeSuccess: VerifyPasswordResetCodeSuccess
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var PasswordManagementActionTypes = {
        ChangePasswordRequest: '[Auth/Password] Change Password Request',
        ChangePasswordError: '[Auth/Password] Change Password Error',
        ChangePasswordSuccess: '[Auth/Password] Change Password Success',
        ResetPasswordStatus: '[Auth/Password] Reset Change Password Status',
        ResetPasswordRequest: '[Auth/Password] Reset Password Request',
        ResetPasswordRequestError: '[Auth/Password] Reset Password Request Error',
        ResetPasswordRequestSuccess: '[Auth/Password] Reset Password Request Success',
    };
    var ChangePasswordRequest = /** @class */ (function () {
        function ChangePasswordRequest(payload) {
            this.payload = payload;
            this.type = PasswordManagementActionTypes.ChangePasswordRequest;
        }
        return ChangePasswordRequest;
    }());
    var ChangePasswordError = /** @class */ (function () {
        function ChangePasswordError(payload) {
            this.payload = payload;
            this.type = PasswordManagementActionTypes.ChangePasswordError;
        }
        return ChangePasswordError;
    }());
    var ChangePasswordSuccess = /** @class */ (function () {
        function ChangePasswordSuccess() {
            this.type = PasswordManagementActionTypes.ChangePasswordSuccess;
        }
        return ChangePasswordSuccess;
    }());
    var ResetPasswordStatus = /** @class */ (function () {
        function ResetPasswordStatus() {
            this.type = PasswordManagementActionTypes.ResetPasswordStatus;
        }
        return ResetPasswordStatus;
    }());
    var ResetPasswordRequest = /** @class */ (function () {
        function ResetPasswordRequest(payload) {
            this.payload = payload;
            this.type = PasswordManagementActionTypes.ResetPasswordRequest;
        }
        return ResetPasswordRequest;
    }());
    var ResetPasswordRequestError = /** @class */ (function () {
        function ResetPasswordRequestError(payload) {
            this.payload = payload;
            this.type = PasswordManagementActionTypes.ResetPasswordRequestError;
        }
        return ResetPasswordRequestError;
    }());
    var ResetPasswordRequestSuccess = /** @class */ (function () {
        function ResetPasswordRequestSuccess() {
            this.type = PasswordManagementActionTypes.ResetPasswordRequestSuccess;
        }
        return ResetPasswordRequestSuccess;
    }());

    var passwordManagement_actions = /*#__PURE__*/Object.freeze({
        PasswordManagementActionTypes: PasswordManagementActionTypes,
        ChangePasswordRequest: ChangePasswordRequest,
        ChangePasswordError: ChangePasswordError,
        ChangePasswordSuccess: ChangePasswordSuccess,
        ResetPasswordStatus: ResetPasswordStatus,
        ResetPasswordRequest: ResetPasswordRequest,
        ResetPasswordRequestError: ResetPasswordRequestError,
        ResetPasswordRequestSuccess: ResetPasswordRequestSuccess
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var ProvidersManagementActionTypes = {
        CodeSent: '[Auth/Providers] Code Sent',
        LinkCredentialAccount: '[Auth/Providers] Link Credential Account',
        LinkFacebookAccount: '[Auth/Providers] Link Facebook Account',
        LinkGoogleAccount: '[Auth/Providers] Link Google Account',
        LinkError: '[Auth/Providers] Link Error',
        LinkSuccess: '[Auth/Providers] Link Success',
        SetProviders: '[Auth/Providers] Set Providers',
        UnlinkCredentialAccount: '[Auth/Providers] Unlink Credential Account',
        UnlinkFacebookAccount: '[Auth/Providers] Unlink Facebook Account',
        UnlinkGoogleAccount: '[Auth/Providers] Unlink Google Account',
        UnlinkError: '[Auth/Providers] Unlink Error',
        UnlinkSuccess: '[Auth/Providers] Unlink Success',
        SendPhoneNumberCode: '[Auth] Send Phone Number Code',
        UnlinkPhoneNumber: '[Auth] Unlink Phone Number',
        VerifyPhoneNumber: '[Auth] Verify Phone',
    };
    var LinkCredentialAccount = /** @class */ (function () {
        function LinkCredentialAccount(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.LinkCredentialAccount;
        }
        return LinkCredentialAccount;
    }());
    var LinkFacebookAccount = /** @class */ (function () {
        function LinkFacebookAccount() {
            this.type = ProvidersManagementActionTypes.LinkFacebookAccount;
        }
        return LinkFacebookAccount;
    }());
    var LinkGoogleAccount = /** @class */ (function () {
        function LinkGoogleAccount() {
            this.type = ProvidersManagementActionTypes.LinkGoogleAccount;
        }
        return LinkGoogleAccount;
    }());
    var VerifyPhoneNumber = /** @class */ (function () {
        function VerifyPhoneNumber(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.VerifyPhoneNumber;
        }
        return VerifyPhoneNumber;
    }());
    var LinkSuccess = /** @class */ (function () {
        function LinkSuccess(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.LinkSuccess;
        }
        return LinkSuccess;
    }());
    var LinkError = /** @class */ (function () {
        function LinkError(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.LinkError;
        }
        return LinkError;
    }());
    var UnlinkSuccess = /** @class */ (function () {
        function UnlinkSuccess(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.UnlinkSuccess;
        }
        return UnlinkSuccess;
    }());
    var UnlinkError = /** @class */ (function () {
        function UnlinkError(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.UnlinkError;
        }
        return UnlinkError;
    }());
    var SendPhoneNumberCode = /** @class */ (function () {
        function SendPhoneNumberCode(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.SendPhoneNumberCode;
        }
        return SendPhoneNumberCode;
    }());
    var UnlinkFacebookAccount = /** @class */ (function () {
        function UnlinkFacebookAccount() {
            this.type = ProvidersManagementActionTypes.UnlinkFacebookAccount;
        }
        return UnlinkFacebookAccount;
    }());
    var UnlinkGoogleAccount = /** @class */ (function () {
        function UnlinkGoogleAccount() {
            this.type = ProvidersManagementActionTypes.UnlinkGoogleAccount;
        }
        return UnlinkGoogleAccount;
    }());
    var UnlinkCredentialAccount = /** @class */ (function () {
        function UnlinkCredentialAccount() {
            this.type = ProvidersManagementActionTypes.UnlinkCredentialAccount;
        }
        return UnlinkCredentialAccount;
    }());
    var SetProviders = /** @class */ (function () {
        function SetProviders(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.SetProviders;
        }
        return SetProviders;
    }());
    var CodeSent = /** @class */ (function () {
        function CodeSent() {
            this.type = ProvidersManagementActionTypes.CodeSent;
        }
        return CodeSent;
    }());
    var UnlinkPhoneNumber = /** @class */ (function () {
        function UnlinkPhoneNumber() {
            this.type = ProvidersManagementActionTypes.UnlinkPhoneNumber;
        }
        return UnlinkPhoneNumber;
    }());

    var providersManagement_actions = /*#__PURE__*/Object.freeze({
        ProvidersManagementActionTypes: ProvidersManagementActionTypes,
        LinkCredentialAccount: LinkCredentialAccount,
        LinkFacebookAccount: LinkFacebookAccount,
        LinkGoogleAccount: LinkGoogleAccount,
        VerifyPhoneNumber: VerifyPhoneNumber,
        LinkSuccess: LinkSuccess,
        LinkError: LinkError,
        UnlinkSuccess: UnlinkSuccess,
        UnlinkError: UnlinkError,
        SendPhoneNumberCode: SendPhoneNumberCode,
        UnlinkFacebookAccount: UnlinkFacebookAccount,
        UnlinkGoogleAccount: UnlinkGoogleAccount,
        UnlinkCredentialAccount: UnlinkCredentialAccount,
        SetProviders: SetProviders,
        CodeSent: CodeSent,
        UnlinkPhoneNumber: UnlinkPhoneNumber
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var AuthActionTypes = {
        Authenticated: '[Auth] Authenticated',
        AuthError: '[Auth] Error',
        CredentialsLogin: '[Auth] Credentials Login Attempt',
        CredentialsReAuthentication: '[Auth] Credentials ReAuthentication attempt',
        CredentialsRegistration: '[Auth] Credentials Registration Attempt',
        DeleteAccount: '[Auth] Delete Account',
        DeleteAccountSuccess: '[Auth] Delete Account Success',
        DeleteAccountError: '[Auth] Delete Account Error',
        FacebookLogin: '[Auth] Facebook Login Attempt',
        FacebookReAuthentication: '[Auth] Facebook ReAuthentication Attempt',
        FacebookRegistration: '[Auth] Facebook Registration Attempt',
        GetUser: '[Auth] Get User',
        GoogleLogin: '[Auth] Google Login Attempt',
        GoogleReAuthentication: '[Auth] Google ReAuthentication Attempt',
        GoogleRegistration: '[Auth] Google Registration Attempt',
        Logout: '[Auth] Logout',
        NotAuthenticated: '[Auth] Not Authenticated',
        SendVerificationEmail: '[Auth] Send Verification Email',
        ReAuthenticationError: '[Auth] ReAuthentication Error',
        ReAuthenticationSuccess: '[Auth] ReAuthentication Success',
        RefreshToken: '[Auth] ReFresh Token',
        RegistrationSuccess: '[Auth] Registration Success',
        ResetAuthState: '[Auth] Reset State',
        VerificationEmailError: '[Auth] Verification Email Error',
        VerificationEmailSent: '[Auth] Verification Email Sent',
    };
    var GetUser = /** @class */ (function () {
        function GetUser(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.GetUser;
        }
        return GetUser;
    }());
    var Authenticated = /** @class */ (function () {
        function Authenticated(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.Authenticated;
        }
        return Authenticated;
    }());
    var NotAuthenticated = /** @class */ (function () {
        function NotAuthenticated(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.NotAuthenticated;
        }
        return NotAuthenticated;
    }());
    var AuthError = /** @class */ (function () {
        function AuthError(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.AuthError;
        }
        return AuthError;
    }());
    var GoogleRegistration = /** @class */ (function () {
        function GoogleRegistration(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.GoogleRegistration;
        }
        return GoogleRegistration;
    }());
    var FacebookRegistration = /** @class */ (function () {
        function FacebookRegistration(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.FacebookRegistration;
        }
        return FacebookRegistration;
    }());
    var CredentialsRegistration = /** @class */ (function () {
        function CredentialsRegistration(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.CredentialsRegistration;
        }
        return CredentialsRegistration;
    }());
    var RegistrationSuccess = /** @class */ (function () {
        function RegistrationSuccess(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.RegistrationSuccess;
        }
        return RegistrationSuccess;
    }());
    var Logout = /** @class */ (function () {
        function Logout(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.Logout;
        }
        return Logout;
    }());
    var GoogleLogin = /** @class */ (function () {
        function GoogleLogin(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.GoogleLogin;
        }
        return GoogleLogin;
    }());
    var FacebookLogin = /** @class */ (function () {
        function FacebookLogin(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.FacebookLogin;
        }
        return FacebookLogin;
    }());
    var CredentialsLogin = /** @class */ (function () {
        function CredentialsLogin(email, password, remember) {
            this.email = email;
            this.password = password;
            this.remember = remember;
            this.type = AuthActionTypes.CredentialsLogin;
        }
        return CredentialsLogin;
    }());
    var GoogleReAuthentication = /** @class */ (function () {
        function GoogleReAuthentication(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.GoogleReAuthentication;
        }
        return GoogleReAuthentication;
    }());
    var FacebookReAuthentication = /** @class */ (function () {
        function FacebookReAuthentication(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.FacebookReAuthentication;
        }
        return FacebookReAuthentication;
    }());
    var CredentialsReAuthentication = /** @class */ (function () {
        function CredentialsReAuthentication(email, password, remember) {
            this.email = email;
            this.password = password;
            this.remember = remember;
            this.type = AuthActionTypes.CredentialsReAuthentication;
        }
        return CredentialsReAuthentication;
    }());
    var ReAuthenticationSuccess = /** @class */ (function () {
        function ReAuthenticationSuccess() {
            this.type = AuthActionTypes.ReAuthenticationSuccess;
        }
        return ReAuthenticationSuccess;
    }());
    var ReAuthenticationError = /** @class */ (function () {
        function ReAuthenticationError(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.ReAuthenticationError;
        }
        return ReAuthenticationError;
    }());
    var SendVerificationEmail = /** @class */ (function () {
        function SendVerificationEmail(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.SendVerificationEmail;
        }
        return SendVerificationEmail;
    }());
    var VerificationEmailError = /** @class */ (function () {
        function VerificationEmailError(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.VerificationEmailError;
        }
        return VerificationEmailError;
    }());
    var VerificationEmailSent = /** @class */ (function () {
        function VerificationEmailSent() {
            this.type = AuthActionTypes.VerificationEmailSent;
        }
        return VerificationEmailSent;
    }());
    var DeleteAccount = /** @class */ (function () {
        function DeleteAccount() {
            this.type = AuthActionTypes.DeleteAccount;
        }
        return DeleteAccount;
    }());
    var DeleteAccountSuccess = /** @class */ (function () {
        function DeleteAccountSuccess() {
            this.type = AuthActionTypes.DeleteAccountSuccess;
        }
        return DeleteAccountSuccess;
    }());
    var DeleteAccountError = /** @class */ (function () {
        function DeleteAccountError(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.DeleteAccountError;
        }
        return DeleteAccountError;
    }());
    var ResetAuthState = /** @class */ (function () {
        function ResetAuthState() {
            this.type = AuthActionTypes.ResetAuthState;
        }
        return ResetAuthState;
    }());
    var RefreshToken = /** @class */ (function () {
        function RefreshToken() {
            this.type = AuthActionTypes.RefreshToken;
        }
        return RefreshToken;
    }());

    var auth_actions = /*#__PURE__*/Object.freeze({
        AuthActionTypes: AuthActionTypes,
        GetUser: GetUser,
        Authenticated: Authenticated,
        NotAuthenticated: NotAuthenticated,
        AuthError: AuthError,
        GoogleRegistration: GoogleRegistration,
        FacebookRegistration: FacebookRegistration,
        CredentialsRegistration: CredentialsRegistration,
        RegistrationSuccess: RegistrationSuccess,
        Logout: Logout,
        GoogleLogin: GoogleLogin,
        FacebookLogin: FacebookLogin,
        CredentialsLogin: CredentialsLogin,
        GoogleReAuthentication: GoogleReAuthentication,
        FacebookReAuthentication: FacebookReAuthentication,
        CredentialsReAuthentication: CredentialsReAuthentication,
        ReAuthenticationSuccess: ReAuthenticationSuccess,
        ReAuthenticationError: ReAuthenticationError,
        SendVerificationEmail: SendVerificationEmail,
        VerificationEmailError: VerificationEmailError,
        VerificationEmailSent: VerificationEmailSent,
        DeleteAccount: DeleteAccount,
        DeleteAccountSuccess: DeleteAccountSuccess,
        DeleteAccountError: DeleteAccountError,
        ResetAuthState: ResetAuthState,
        RefreshToken: RefreshToken
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var defaultState = {
        loggedIn: false,
        user: null,
        loading: true,
        error: null,
        success: false
    };
    /// Reducer function
    /**
     * @param {?=} state
     * @param {?=} action
     * @return {?}
     */
    function reducer(state, action) {
        if (state === void 0) {
            state = defaultState;
        }
        switch (action.type) {
            case AuthActionTypes.GetUser:
                return __assign({}, state, { loading: true, success: false });
            case AuthActionTypes.Authenticated:
            case AuthActionTypes.RegistrationSuccess:
                return __assign({}, state, { user: action.payload.user, loading: false, loggedIn: true, success: false });
            case AuthActionTypes.NotAuthenticated:
                return __assign({}, state, defaultState, { loading: false, loggedIn: false, success: false });
            case AuthActionTypes.GoogleLogin:
            case AuthActionTypes.FacebookLogin:
            case AuthActionTypes.GoogleRegistration:
            case AuthActionTypes.FacebookRegistration:
            case AuthActionTypes.CredentialsLogin:
            case AuthActionTypes.CredentialsRegistration:
            case AuthActionTypes.FacebookReAuthentication:
            case AuthActionTypes.CredentialsReAuthentication:
            case AuthActionTypes.GoogleReAuthentication:
                return __assign({}, state, { loading: true, success: false });
            case AuthActionTypes.ResetAuthState:
                return __assign({}, state, { loading: false, success: false, error: null });
            case AuthActionTypes.AuthError:
            case AuthActionTypes.ReAuthenticationError:
                return __assign({}, state, { loading: false, success: false, error: action.payload });
            case AuthActionTypes.ReAuthenticationSuccess:
                return __assign({}, state, { loading: false, error: null, success: true });
            case AuthActionTypes.Logout:
                return __assign({}, state, { loading: true });
            case AuthActionTypes.DeleteAccount:
                return __assign({}, state, { loading: true, success: true, error: null });
            case AuthActionTypes.DeleteAccountError:
                return __assign({}, state, { loading: false, success: false, error: action.payload });
            case AuthActionTypes.DeleteAccountSuccess:
                return __assign({}, state, { loading: false, loggedIn: false, success: true, error: null, user: null });
            case CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess:
                return __assign({}, state, { user: __assign({}, state.user, { emailVerified: true }) });
            default:
                return state;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var initialState = ( /** @type {?} */({
        loading: false,
        success: false,
        error: null
    }));
    /**
     * @param {?=} state
     * @param {?=} action
     * @return {?}
     */
    function reducer$1(state, action) {
        if (state === void 0) {
            state = initialState;
        }
        switch (action.type) {
            case PasswordManagementActionTypes.ResetPasswordRequest:
            case PasswordManagementActionTypes.ChangePasswordRequest: {
                return __assign({}, state, { loading: true, success: false, error: null });
            }
            case PasswordManagementActionTypes.ResetPasswordRequestError:
            case PasswordManagementActionTypes.ChangePasswordError: {
                return __assign({}, state, { loading: false, success: false, error: action.payload });
            }
            case PasswordManagementActionTypes.ResetPasswordRequestSuccess:
            case PasswordManagementActionTypes.ChangePasswordSuccess: {
                return __assign({}, state, { loading: false, success: true, error: null });
            }
            case PasswordManagementActionTypes.ResetPasswordStatus: {
                return __assign({}, state, { loading: false, success: false, error: null });
            }
            default:
                return state;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var initialState$1 = ( /** @type {?} */({
        loading: false,
        success: false,
        providers: {
            facebook: false,
            google: false,
            phone: false,
            password: false
        },
        error: null
    }));
    /**
     * @param {?=} state
     * @param {?=} action
     * @return {?}
     */
    function reducer$2(state, action) {
        if (state === void 0) {
            state = initialState$1;
        }
        var _a, _b;
        switch (action.type) {
            case ProvidersManagementActionTypes.SetProviders:
                return __assign({}, state, { providers: __assign({}, state.providers, action.payload) });
            case ProvidersManagementActionTypes.LinkCredentialAccount:
            case ProvidersManagementActionTypes.LinkFacebookAccount:
            case ProvidersManagementActionTypes.LinkGoogleAccount:
            case ProvidersManagementActionTypes.UnlinkCredentialAccount:
            case ProvidersManagementActionTypes.UnlinkGoogleAccount:
            case ProvidersManagementActionTypes.UnlinkFacebookAccount:
                return __assign({}, state, { success: false, error: null, loading: true });
            case ProvidersManagementActionTypes.LinkSuccess:
                return __assign({}, state, { providers: __assign({}, state.providers, (_a = {}, _a[action.payload.provider] = true, _a)), success: true, error: null, loading: false });
            case ProvidersManagementActionTypes.UnlinkSuccess:
                return __assign({}, state, { providers: __assign({}, state.providers, (_b = {}, _b[action.payload.provider] = false, _b)), success: true, error: null, loading: false });
            case ProvidersManagementActionTypes.LinkError:
            case ProvidersManagementActionTypes.UnlinkError:
                return __assign({}, state, { success: false, error: action.payload, loading: false });
            default:
                return state;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var initialRequestStatus = {
        loading: false,
        success: false,
        error: null
    };
    /** @type {?} */
    var initialState$2 = ( /** @type {?} */({
        emailVerified: __assign({}, initialRequestStatus),
        passwordResetCode: __assign({}, initialRequestStatus),
        resetPassword: __assign({}, initialRequestStatus),
        checkCode: __assign({}, initialRequestStatus),
        recoverEmail: __assign({}, initialRequestStatus)
    }));
    /**
     * @param {?=} state
     * @param {?=} action
     * @return {?}
     */
    function reducer$3(state, action) {
        if (state === void 0) {
            state = initialState$2;
        }
        switch (action.type) {
            case CustomEmailHandlerActionTypes.VerifyEmailAddress: {
                return __assign({}, state, { emailVerified: { loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.VerifyEmailAddressError: {
                return __assign({}, state, { emailVerified: { loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess: {
                return __assign({}, state, { emailVerified: { loading: false, success: true, error: null } });
            }
            case CustomEmailHandlerActionTypes.VerifyPasswordResetCode: {
                return __assign({}, state, { passwordResetCode: { email: null, loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.VerifyPasswordResetCodeError: {
                return __assign({}, state, { passwordResetCode: { email: null, loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.VerifyPasswordResetCodeSuccess: {
                return __assign({}, state, { passwordResetCode: { email: action.payload.email, loading: false, success: true, error: null } });
            }
            case CustomEmailHandlerActionTypes.CheckActionCode: {
                return __assign({}, state, { checkCode: { loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.CheckActionCodeError: {
                return __assign({}, state, { checkCode: { loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.CheckActionCodeSuccess: {
                return __assign({}, state, { checkCode: { loading: false, success: true, error: null } });
            }
            case CustomEmailHandlerActionTypes.RecoverEmail: {
                return __assign({}, state, { recoverEmail: { loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.RecoverEmailError: {
                return __assign({}, state, { recoverEmail: { loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.RecoverEmailSuccess: {
                return __assign({}, state, { recoverEmail: { loading: false, success: true, error: null } });
            }
            case CustomEmailHandlerActionTypes.ResetPassword: {
                return __assign({}, state, { resetPassword: { loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.ResetPasswordError: {
                return __assign({}, state, { resetPassword: { loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.ResetPasswordSuccess: {
                return __assign({}, state, { resetPassword: { loading: false, success: true, error: null } });
            }
            default:
                return state;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var reducers = {
        user: reducer,
        changePassword: reducer$1,
        providers: reducer$2,
        customEmailHandler: reducer$3
    };
    /** @type {?} */
    var getAuthState = store.createFeatureSelector('auth');
    /** @type {?} */
    var getUserState = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.user; }));
    /** @type {?} */
    var isAuthLoading = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.user.loading; }));
    /** @type {?} */
    var isUserLogged = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.user.loggedIn && state.user.user && state.user.user.emailVerified; }));
    /** @type {?} */
    var getUser = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.user.user; }));
    /** @type {?} */
    var getAuthError = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.user.error; }));
    /** @type {?} */
    var isAuthSuccess = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.user.success; }));
    /** @type {?} */
    var getChangePasswordStatus = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.changePassword; }));
    /** @type {?} */
    var getUserProvidersState = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.providers; }));
    /** @type {?} */
    var getUserProviders = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.providers.providers; }));
    /** @type {?} */
    var getProvidersRequestStatus = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) {
        return {
            loading: state.providers.loading,
            error: state.providers.error,
            success: state.providers.success
        };
    }));
    /** @type {?} */
    var getCustomEmailHandlerRequestStatus = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) {
        return {
            emailVerified: {
                loading: state.customEmailHandler.emailVerified.loading,
                error: state.customEmailHandler.emailVerified.error,
                success: state.customEmailHandler.emailVerified.success
            }
        };
    }));
    /** @type {?} */
    var getEmailVerifiedStatus = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.emailVerified; }));
    /** @type {?} */
    var getPasswordResetStatus = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.resetPassword; }));
    /** @type {?} */
    var getVerifyResetPasswordProcedure = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.passwordResetCode; }));
    /** @type {?} */
    var getEmailVerifiedError = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.emailVerified.error; }));
    /** @type {?} */
    var isEmailVerifiedLoading = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.emailVerified.loading; }));
    /** @type {?} */
    var getPasswordResetCodeError = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.passwordResetCode.error; }));
    /** @type {?} */
    var isPasswordResetCodeLoading = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.passwordResetCode.loading; }));
    /** @type {?} */
    var getPasswordResetCodeEmail = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.passwordResetCode.email; }));
    /** @type {?} */
    var getResetPasswordError = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.resetPassword.error; }));
    /** @type {?} */
    var isResetPasswordLoading = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.resetPassword.loading; }));
    /** @type {?} */
    var getCheckCodeError = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.checkCode.error; }));
    /** @type {?} */
    var isCheckCodeLoading = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.checkCode.loading; }));
    /** @type {?} */
    var getRecoverEmailError = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.recoverEmail.error; }));
    /** @type {?} */
    var isRecoverEmailLoading = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.recoverEmail.loading; }));
    /** @type {?} */
    var getResetPasswordOrCodeError = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.resetPassword.error || state.customEmailHandler.passwordResetCode.error; }));
    /** @type {?} */
    var getResetPasswordSuccess = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.resetPassword.success; }));
    /** @type {?} */
    var isResetPasswordOrCodeLoading = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.resetPassword.loading || state.customEmailHandler.passwordResetCode.loading; }));
    /** @type {?} */
    var getRecoverEmailOrCheckCodeError = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.recoverEmail.error || state.customEmailHandler.checkCode.error; }));
    /** @type {?} */
    var isRecoverEmailOrCheckCodeLoading = store.createSelector(getAuthState, ( /**
     * @param {?} state
     * @return {?}
     */function (state) { return state.customEmailHandler.recoverEmail.loading || state.customEmailHandler.checkCode.loading; }));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FirebaseNgrxUserManagementService = /** @class */ (function () {
        function FirebaseNgrxUserManagementService() {
        }
        FirebaseNgrxUserManagementService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        FirebaseNgrxUserManagementService.ctorParameters = function () { return []; };
        /** @nocollapse */ FirebaseNgrxUserManagementService.ngInjectableDef = i0.defineInjectable({ factory: function FirebaseNgrxUserManagementService_Factory() { return new FirebaseNgrxUserManagementService(); }, token: FirebaseNgrxUserManagementService, providedIn: "root" });
        return FirebaseNgrxUserManagementService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var FIREBASE_USER_MANAGEMENT_CONFIG = new i0.InjectionToken('userManagement.config');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var PROVIDERS_MAP = {};
    PROVIDERS_MAP[firebase.auth.FacebookAuthProvider.FACEBOOK_SIGN_IN_METHOD] = 'facebook';
    PROVIDERS_MAP[firebase.auth.GoogleAuthProvider.GOOGLE_SIGN_IN_METHOD] = 'google';
    PROVIDERS_MAP[firebase.auth.EmailAuthProvider.EMAIL_PASSWORD_SIGN_IN_METHOD] = 'password';
    PROVIDERS_MAP[firebase.auth.PhoneAuthProvider.PHONE_SIGN_IN_METHOD] = 'phone';
    var LoginEffects = /** @class */ (function () {
        function LoginEffects(actions$, afAuth, fb, gplus, platform, config) {
            var _this = this;
            this.actions$ = actions$;
            this.afAuth = afAuth;
            this.fb = fb;
            this.gplus = gplus;
            this.platform = platform;
            this.config = config;
            this.getUser = this.actions$.pipe(effects.ofType(AuthActionTypes.GetUser), operators.exhaustMap(( /**
             * @return {?}
             */function () {
                return _this.afAuth.authState.pipe(operators.take(1), operators.switchMap(( /**
                 * @param {?} authData
                 * @return {?}
                 */function (authData) {
                    console.debug(authData);
                    if (authData) {
                        /// User logged in
                        console.debug('USER', authData);
                        return rxjs.zip(rxjs.from(authData.getIdToken(true))).pipe(operators.switchMap(( /**
                         * @param {?} res
                         * @return {?}
                         */function (res) {
                            console.debug('providers found', authData.providerData);
                            /** @type {?} */
                            var providers = authData.providerData.reduce(( /**
                             * @param {?} prev
                             * @param {?} current
                             * @return {?}
                             */function (prev, current) {
                                /** @type {?} */
                                var key = PROVIDERS_MAP[current.providerId];
                                if (key) {
                                    prev[key] = true;
                                }
                                return prev;
                            }), {});
                            console.debug(providers, authData.providerData.map(( /**
                             * @param {?} p
                             * @return {?}
                             */function (p) { return p.providerId; })));
                            /** @type {?} */
                            var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, authData.photoURL, authData.emailVerified);
                            return ( /** @type {?} */(rxjs.from([new SetProviders(providers), new Authenticated({ user: user })])));
                        })));
                    }
                    else {
                        return ( /** @type {?} */(rxjs.of(new NotAuthenticated())));
                    }
                })));
            })));
            this.googleLogin = this.actions$.pipe(effects.ofType(AuthActionTypes.GoogleLogin), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.doGoogleLogin()).pipe(operators.map(( /**
                 * @param {?} credential
                 * @return {?}
                 */function (credential) {
                    // successful login
                    return new GetUser();
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.facebookLogin = this.actions$.pipe(effects.ofType(AuthActionTypes.FacebookLogin), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.doFacebookLogin()).pipe(operators.map(( /**
                 * @param {?} credential
                 * @return {?}
                 */function (credential) {
                    // successful login
                    return new GetUser();
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.loginWithCredentials = this.actions$.pipe(effects.ofType(AuthActionTypes.CredentialsLogin), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) {
                return {
                    email: action.email,
                    password: action.password,
                    remember: (action.remember) ? action.remember : false
                };
            })), operators.exhaustMap(( /**
             * @param {?} credentials
             * @return {?}
             */function (credentials) {
                return rxjs.from(_this.doLoginWithCredentials(credentials)).pipe(operators.map(( /**
                 * @param {?} p
                 * @return {?}
                 */function (p) {
                    // successful login
                    return new GetUser();
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.logout = this.actions$.pipe(effects.ofType(AuthActionTypes.Logout), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.afAuth.auth.signOut());
            })), operators.map(( /**
             * @param {?} authData
             * @return {?}
             */function (authData) {
                return new NotAuthenticated();
            })));
            this.refreshToken$ = this.actions$.pipe(effects.ofType(AuthActionTypes.RefreshToken), operators.switchMap(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return rxjs.of(_this.afAuth.auth.currentUser.getIdToken(true)); })), operators.switchMap(( /**
             * @param {?} a
             * @return {?}
             */function (a) {
                console.debug('reloading user');
                return rxjs.of(_this.afAuth.auth.currentUser.reload());
            })), operators.map(( /**
             * @param {?} a
             * @return {?}
             */function (a) { return new GetUser(); })));
        }
        /**
         * @private
         * @return {?}
         */
        LoginEffects.prototype.doFacebookLogin = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.platform.is('cordova')) {
                    return this.doFacebookLoginMobile();
                }
                else {
                    /** @type {?} */
                    var provider = new firebase.auth.FacebookAuthProvider();
                    return this.afAuth.auth.signInWithPopup(provider);
                }
            };
        /**
         * @private
         * @return {?}
         */
        LoginEffects.prototype.doFacebookLoginMobile = /**
         * @private
         * @return {?}
         */
            function () {
                return this.fb.login(['public_profile', 'email'])
                    .then(( /**
             * @param {?} res
             * @return {?}
             */function (res) {
                    /** @type {?} */
                    var facebookCredential = firebase.auth.FacebookAuthProvider.credential(res.authResponse.accessToken);
                    return firebase.auth().signInWithCredential(facebookCredential);
                }));
            };
        /**
         * @private
         * @return {?}
         */
        LoginEffects.prototype.doGoogleLogin = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.platform.is('cordova')) {
                    return this.doGoogleLoginMobile();
                }
                else {
                    /** @type {?} */
                    var provider = new firebase.auth.GoogleAuthProvider();
                    provider.setCustomParameters({
                        prompt: 'select_account'
                    });
                    return this.afAuth.auth.signInWithPopup(provider);
                }
            };
        /**
         * @private
         * @return {?}
         */
        LoginEffects.prototype.doGoogleLoginMobile = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                console.debug('Logging in into googlw mobile');
                /** @type {?} */
                var loginP = this.gplus.login({
                    webClientId: this.config.googleWebClientId,
                    offline: true,
                    scopes: 'profile email'
                });
                loginP.catch(console.error);
                return loginP.then(( /**
                 * @param {?} gplusUser
                 * @return {?}
                 */function (gplusUser) {
                    console.debug('Logging in into googlw mobile', gplusUser);
                    return _this.afAuth.auth.signInWithCredential(firebase.auth.GoogleAuthProvider.credential(gplusUser.idToken));
                }));
            };
        /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
        LoginEffects.prototype.doLoginWithCredentials = /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
            function (credentials) {
                var _this = this;
                if (credentials.remember) {
                    return this.afAuth.auth.setPersistence(firebase.auth.Auth.Persistence.LOCAL).then(( /**
                     * @return {?}
                     */function () {
                        return _this.afAuth.auth.signInWithEmailAndPassword(credentials.email, credentials.password);
                    }));
                }
                else {
                    return this.afAuth.auth.setPersistence(firebase.auth.Auth.Persistence.SESSION).then(( /**
                     * @return {?}
                     */function () {
                        return _this.afAuth.auth.signInWithEmailAndPassword(credentials.email, credentials.password);
                    }));
                }
            };
        LoginEffects.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        LoginEffects.ctorParameters = function () {
            return [
                { type: effects.Actions },
                { type: auth$1.AngularFireAuth },
                { type: ngx.Facebook },
                { type: ngx$1.GooglePlus },
                { type: angular.Platform },
                { type: undefined, decorators: [{ type: i0.Inject, args: [FIREBASE_USER_MANAGEMENT_CONFIG,] }] }
            ];
        };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "getUser", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "googleLogin", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "facebookLogin", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "loginWithCredentials", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "logout", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", Object)
        ], LoginEffects.prototype, "refreshToken$", void 0);
        return LoginEffects;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RegistrationEffects = /** @class */ (function () {
        function RegistrationEffects(actions, fb, gplus, platform, afAuth, config) {
            var _this = this;
            this.actions = actions;
            this.fb = fb;
            this.gplus = gplus;
            this.platform = platform;
            this.afAuth = afAuth;
            this.config = config;
            this.googleSignUp = this.actions.pipe(effects.ofType(AuthActionTypes.GoogleRegistration), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.doGoogleLogin()).pipe(operators.switchMap(( /**
                 * @param {?} credential
                 * @return {?}
                 */function (credential) {
                    console.debug('credential', credential);
                    /** @type {?} */
                    var authData = credential.user;
                    /** @type {?} */
                    var photoUrl = authData.photoURL;
                    /** @type {?} */
                    var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, photoUrl, authData.emailVerified);
                    return rxjs.from([new SetProviders({ google: true }), new RegistrationSuccess({ user: user })]);
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) {
                    console.error(error);
                    return rxjs.of(new AuthError(error));
                })));
            })));
            this.facebookSignUp = this.actions.pipe(effects.ofType(AuthActionTypes.FacebookRegistration), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.doFacebookLogin()).pipe(operators.switchMap(( /**
                 * @param {?} credential
                 * @return {?}
                 */function (credential) {
                    console.debug('facebookSignUp', credential);
                    /** @type {?} */
                    var authData = credential.user;
                    /** @type {?} */
                    var photoUrl = authData.photoURL;
                    console.log('PhotoUrl', photoUrl);
                    /** @type {?} */
                    var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, photoUrl, authData.emailVerified);
                    return rxjs.from([new SetProviders({ facebook: true }), new RegistrationSuccess({ user: user })]);
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.signUpWithCredentials = this.actions.pipe(effects.ofType(AuthActionTypes.CredentialsRegistration), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) {
                return {
                    email: action.payload.email,
                    password: action.payload.password
                };
            })), operators.exhaustMap(( /**
             * @param {?} credentials
             * @return {?}
             */function (credentials) {
                return rxjs.from(_this.doSignUpWithCredentials(credentials)).pipe(operators.map(( /**
                 * @param {?} credential
                 * @return {?}
                 */function (credential) {
                    console.debug('doSignUpWithCredentials', credential);
                    /** @type {?} */
                    var authData = credential.user;
                    /** @type {?} */
                    var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, authData.photoURL, authData.emailVerified);
                    return new RegistrationSuccess({ user: user });
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.sendVerificationEmail$ = this.actions.pipe(effects.ofType(AuthActionTypes.SendVerificationEmail), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.afAuth.auth.currentUser.sendEmailVerification({ url: payload.redirectUrl })).pipe(operators.map(( /**
                 * @param {?} p
                 * @return {?}
                 */function (p) {
                    return new VerificationEmailSent();
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new VerificationEmailError(error)); })));
            })));
        }
        /**
         * @private
         * @return {?}
         */
        RegistrationEffects.prototype.doFacebookLogin = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.platform.is('cordova')) {
                    return this.doFacebookLoginMobile();
                }
                else {
                    /** @type {?} */
                    var provider = new firebase.auth.FacebookAuthProvider();
                    return this.afAuth.auth.signInWithPopup(provider);
                }
            };
        /**
         * @private
         * @return {?}
         */
        RegistrationEffects.prototype.doFacebookLoginMobile = /**
         * @private
         * @return {?}
         */
            function () {
                return this.fb.login(['public_profile', 'email', 'user_friends', 'user_birthday'])
                    .then(( /**
             * @param {?} res
             * @return {?}
             */function (res) {
                    /** @type {?} */
                    var facebookCredential = firebase.auth.FacebookAuthProvider.credential(res.authResponse.accessToken);
                    return firebase.auth().signInAndRetrieveDataWithCredential(facebookCredential);
                }));
            };
        /**
         * @private
         * @return {?}
         */
        RegistrationEffects.prototype.doGoogleLogin = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.platform.is('cordova')) {
                    return this.doGoogleLoginMobile();
                }
                else {
                    /** @type {?} */
                    var provider = new firebase.auth.GoogleAuthProvider();
                    provider.setCustomParameters({
                        prompt: 'select_account'
                    });
                    return this.afAuth.auth.signInWithPopup(provider);
                }
            };
        /**
         * @private
         * @return {?}
         */
        RegistrationEffects.prototype.doGoogleLoginMobile = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                console.debug('Logging in into googlw mobile');
                /** @type {?} */
                var loginP = this.gplus.login({
                    webClientId: this.config.googleWebClientId,
                    offline: true,
                    scopes: 'profile email'
                });
                loginP.catch(console.error);
                return loginP.then(( /**
                 * @param {?} gplusUser
                 * @return {?}
                 */function (gplusUser) {
                    console.debug('Logging in into googlw mobile', gplusUser);
                    return _this.afAuth.auth.signInAndRetrieveDataWithCredential(firebase.auth.GoogleAuthProvider.credential(gplusUser.idToken));
                }));
            };
        /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
        RegistrationEffects.prototype.doSignUpWithCredentials = /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
            function (credentials) {
                return this.afAuth.auth.createUserWithEmailAndPassword(credentials.email, credentials.password);
            };
        RegistrationEffects.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        RegistrationEffects.ctorParameters = function () {
            return [
                { type: effects.Actions },
                { type: ngx.Facebook },
                { type: ngx$1.GooglePlus },
                { type: angular.Platform },
                { type: auth$1.AngularFireAuth },
                { type: undefined, decorators: [{ type: i0.Inject, args: [FIREBASE_USER_MANAGEMENT_CONFIG,] }] }
            ];
        };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], RegistrationEffects.prototype, "googleSignUp", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], RegistrationEffects.prototype, "facebookSignUp", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], RegistrationEffects.prototype, "signUpWithCredentials", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], RegistrationEffects.prototype, "sendVerificationEmail$", void 0);
        return RegistrationEffects;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ReAuthenticationEffects = /** @class */ (function () {
        function ReAuthenticationEffects(actions, afAuth) {
            var _this = this;
            this.actions = actions;
            this.afAuth = afAuth;
            this.googleReAuthentication = this.actions.pipe(effects.ofType(AuthActionTypes.GoogleReAuthentication), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.doGoogleReAuthentication()).pipe(operators.map(( /**
                 * @param {?} credential
                 * @return {?}
                 */function (credential) {
                    // successful login
                    return new ReAuthenticationSuccess();
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new ReAuthenticationError(error)); })));
            })));
            this.facebookReAuthentication = this.actions.pipe(effects.ofType(AuthActionTypes.FacebookReAuthentication), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.doFacebookReAuthentication()).pipe(operators.map(( /**
                 * @param {?} credential
                 * @return {?}
                 */function (credential) {
                    // successful login
                    return new ReAuthenticationSuccess();
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new ReAuthenticationError(error)); })));
            })));
            this.reAuthenticateWithCredentials = this.actions.pipe(effects.ofType(AuthActionTypes.CredentialsReAuthentication), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) {
                return {
                    email: action.email,
                    password: action.password
                };
            })), operators.exhaustMap(( /**
             * @param {?} credentials
             * @return {?}
             */function (credentials) {
                return rxjs.from(_this.doReAuthenticationWithCredentials(credentials)).pipe(operators.map(( /**
                 * @param {?} p
                 * @return {?}
                 */function (p) {
                    // successful login
                    return new ReAuthenticationSuccess();
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new ReAuthenticationError(error)); })));
            })));
        }
        /**
         * @private
         * @return {?}
         */
        ReAuthenticationEffects.prototype.doFacebookReAuthentication = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var provider = new firebase.auth.FacebookAuthProvider();
                return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
            };
        /**
         * @private
         * @return {?}
         */
        ReAuthenticationEffects.prototype.doGoogleReAuthentication = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var provider = new firebase.auth.GoogleAuthProvider();
                return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
            };
        /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
        ReAuthenticationEffects.prototype.doReAuthenticationWithCredentials = /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
            function (credentials) {
                /** @type {?} */
                var credential = firebase.auth.EmailAuthProvider.credential(credentials.email, credentials.password);
                return this.afAuth.auth.currentUser.reauthenticateAndRetrieveDataWithCredential(credential);
            };
        ReAuthenticationEffects.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        ReAuthenticationEffects.ctorParameters = function () {
            return [
                { type: effects.Actions },
                { type: auth$1.AngularFireAuth }
            ];
        };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ReAuthenticationEffects.prototype, "googleReAuthentication", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ReAuthenticationEffects.prototype, "facebookReAuthentication", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ReAuthenticationEffects.prototype, "reAuthenticateWithCredentials", void 0);
        return ReAuthenticationEffects;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var EmailAuthProvider = firebase.auth.EmailAuthProvider;
    var ProvidersManagementEffects = /** @class */ (function () {
        function ProvidersManagementEffects(actions$, fb, gplus, afAuth, config) {
            var _this = this;
            this.actions$ = actions$;
            this.fb = fb;
            this.gplus = gplus;
            this.afAuth = afAuth;
            this.config = config;
            this.linkToGoogleAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.LinkGoogleAccount), operators.exhaustMap(( /**
             * @param {?} actins
             * @return {?}
             */function (actins) {
                return rxjs.from(_this.doLinkToGoogleProvider()).pipe(operators.mapTo(new LinkSuccess({ provider: 'google' })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new LinkError(error)); })));
            })));
            this.linkToFacebookAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.LinkFacebookAccount), operators.exhaustMap(( /**
             * @param {?} actions
             * @return {?}
             */function (actions) {
                return rxjs.from(_this.doLinkToFacebookProvider()).pipe(operators.mapTo(new LinkSuccess({ provider: 'facebook' })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new LinkError(error)); })));
            })));
            this.linkToCredentialsAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.LinkCredentialAccount), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.reAuthenticate().then(( /**
                 * @param {?} res
                 * @return {?}
                 */function (res) {
                    return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.doLinkToCredentials(this.afAuth.auth.currentUser.email, payload.password)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    });
                }))).pipe(operators.mapTo(new LinkSuccess({ provider: 'password' })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) {
                    if (error.code === 'auth/popup-blocked') {
                        return rxjs.from(_this.reAuthenticateWithRedirect().then(( /**
                         * @param {?} res
                         * @return {?}
                         */function (res) {
                            return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, this.doLinkToCredentials(this.afAuth.auth.currentUser.email, payload.password)];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            });
                        }))).pipe(operators.mapTo(new LinkSuccess({ provider: 'password' })), operators.catchError(( /**
                         * @param {?} error1
                         * @return {?}
                         */function (error1) { return rxjs.of(new LinkError(error1)); })));
                    }
                    else {
                        return rxjs.of(new LinkError(error));
                    }
                })));
            })));
            this.unlinkGoogleAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.UnlinkGoogleAccount), operators.exhaustMap(( /**
             * @param {?} actions
             * @return {?}
             */function (actions) {
                return rxjs.from(_this.doUnlinkToGoogleProvider()).pipe(operators.mapTo(new UnlinkSuccess({ provider: 'google' })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new UnlinkError(error)); })));
            })));
            this.unlinkFacebookAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.UnlinkFacebookAccount), operators.exhaustMap(( /**
             * @param {?} actions
             * @return {?}
             */function (actions) {
                return rxjs.from(_this.doUnlinkToFacebookProvider()).pipe(operators.mapTo(new UnlinkSuccess({ provider: 'facebook' })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new UnlinkError(error)); })));
            })));
            this.unlinkCredentialsAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.UnlinkCredentialAccount), operators.exhaustMap(( /**
             * @param {?} action
             * @return {?}
             */function (action) {
                return rxjs.from(_this.reAuthenticate().then(( /**
                 * @param {?} res
                 * @return {?}
                 */function (res) {
                    return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.doUnlinkToCredentials()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    });
                }))).pipe(operators.mapTo(new UnlinkSuccess({ provider: 'password' })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new UnlinkError(error)); })));
            })));
            this.unlinkPhone$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.UnlinkPhoneNumber), operators.exhaustMap(( /**
             * @param {?} action
             * @return {?}
             */function (action) {
                return rxjs.from(_this.doUnlinkPhoneNumber()).pipe(operators.mapTo(new UnlinkSuccess({ provider: 'phone' })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new UnlinkError(error)); })));
            })));
            this.sendCodeToPhone$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.SendPhoneNumberCode), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from((( /**
                 * @return {?}
                 */function () {
                    return _this.afAuth.auth.currentUser.linkWithPhoneNumber(payload.number, new firebase.auth.RecaptchaVerifier(payload.captchaContainerId, {
                        size: 'invisible',
                        callback: ( /**
                         * @param {?} token
                         * @return {?}
                         */function (token) {
                            console.debug('Captcha token', token);
                        })
                    })).then(( /**
                     * @param {?} confirmation
                     * @return {?}
                     */function (confirmation) {
                        _this.phoneNumberConfirmation = confirmation;
                    }));
                }))()).pipe(operators.mapTo(new CodeSent()), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new LinkError(error)); })));
            })));
            this.verifyCode$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.VerifyPhoneNumber), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.phoneNumberConfirmation.confirm(payload.code)).pipe(operators.mapTo(new LinkSuccess({ provider: 'phone' })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new LinkError(error)); })));
            })));
        }
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doLinkToGoogleProvider = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var loginP = this.gplus.login({
                    webClientId: this.config.googleWebClientId,
                    offline: true,
                    scopes: 'profile email'
                });
                loginP.catch(console.error);
                return loginP.then(( /**
                 * @param {?} gplusUser
                 * @return {?}
                 */function (gplusUser) {
                    console.debug('Logging in into googlw mobile', gplusUser);
                    return _this.afAuth.auth.currentUser.linkWithCredential(firebase.auth.GoogleAuthProvider.credential(gplusUser.idToken));
                }));
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doUnlinkToGoogleProvider = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var provider = new firebase.auth.GoogleAuthProvider();
                return this.afAuth.auth.currentUser.unlink(provider.providerId);
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doLinkToFacebookProvider = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                return this.fb.login(['public_profile', 'email', 'user_friends', 'user_birthday'])
                    .then(( /**
             * @param {?} res
             * @return {?}
             */function (res) {
                    /** @type {?} */
                    var facebookCredential = firebase.auth.FacebookAuthProvider.credential(res.authResponse.accessToken);
                    return _this.afAuth.auth.currentUser.linkWithCredential(facebookCredential);
                }));
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doUnlinkToFacebookProvider = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var provider = new firebase.auth.FacebookAuthProvider();
                return this.afAuth.auth.currentUser.unlink(provider.providerId);
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doUnlinkPhoneNumber = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var provider = new firebase.auth.PhoneAuthProvider();
                return this.afAuth.auth.currentUser.unlink(provider.providerId);
            };
        /**
         * @private
         * @param {?} email
         * @param {?} password
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doLinkToCredentials = /**
         * @private
         * @param {?} email
         * @param {?} password
         * @return {?}
         */
            function (email, password) {
                /** @type {?} */
                var credentials = EmailAuthProvider.credential(email, password);
                return this.afAuth.auth.currentUser.linkAndRetrieveDataWithCredential(credentials);
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doUnlinkToCredentials = /**
         * @private
         * @return {?}
         */
            function () {
                return this.afAuth.auth.currentUser.unlink(EmailAuthProvider.EMAIL_PASSWORD_SIGN_IN_METHOD);
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doFacebookReAuthentication = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var provider = new firebase.auth.FacebookAuthProvider();
                return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doFacebookReAuthenticationWithRedirect = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var provider = new firebase.auth.FacebookAuthProvider();
                return this.afAuth.auth.currentUser.reauthenticateWithRedirect(provider);
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.reAuthenticate = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                return this.afAuth.auth.fetchSignInMethodsForEmail(this.afAuth.auth.currentUser.email).then(( /**
                 * @param {?} res
                 * @return {?}
                 */function (res) {
                    return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!(res.indexOf('facebook.com') >= 0))
                                        return [3 /*break*/, 2];
                                    return [4 /*yield*/, this.doFacebookReAuthentication()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                                case 2: return [4 /*yield*/, this.doGoogleReAuthentication()];
                                case 3:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    });
                }));
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.reAuthenticateWithRedirect = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                return this.afAuth.auth.fetchSignInMethodsForEmail(this.afAuth.auth.currentUser.email).then(( /**
                 * @param {?} res
                 * @return {?}
                 */function (res) {
                    return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!(res.indexOf('facebook.com') >= 0))
                                        return [3 /*break*/, 2];
                                    return [4 /*yield*/, this.doFacebookReAuthenticationWithRedirect()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                                case 2: return [4 /*yield*/, this.doGoogleReAuthenticationWithRedirect()];
                                case 3:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    });
                }));
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doGoogleReAuthentication = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var provider = new firebase.auth.GoogleAuthProvider();
                return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
            };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doGoogleReAuthenticationWithRedirect = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var provider = new firebase.auth.GoogleAuthProvider();
                return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
            };
        ProvidersManagementEffects.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        ProvidersManagementEffects.ctorParameters = function () {
            return [
                { type: effects.Actions },
                { type: ngx.Facebook },
                { type: ngx$1.GooglePlus },
                { type: auth$1.AngularFireAuth },
                { type: undefined, decorators: [{ type: i0.Inject, args: [FIREBASE_USER_MANAGEMENT_CONFIG,] }] }
            ];
        };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "linkToGoogleAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "linkToFacebookAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "linkToCredentialsAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "unlinkGoogleAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "unlinkFacebookAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "unlinkCredentialsAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "unlinkPhone$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "sendCodeToPhone$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "verifyCode$", void 0);
        return ProvidersManagementEffects;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PasswordManagementEffects = /** @class */ (function () {
        function PasswordManagementEffects(actions$, afAuth) {
            var _this = this;
            this.actions$ = actions$;
            this.afAuth = afAuth;
            this.changePassword = this.actions$.pipe(effects.ofType(PasswordManagementActionTypes.ChangePasswordRequest), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                /** @type {?} */
                var credentials = firebase.auth.EmailAuthProvider.credential(_this.afAuth.auth.currentUser.email, payload.oldPassword);
                return rxjs.from(_this.afAuth.auth.currentUser.reauthenticateAndRetrieveDataWithCredential(credentials).then(( /**
                 * @param {?} res
                 * @return {?}
                 */function (res) {
                    return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.afAuth.auth.currentUser.updatePassword(payload.newPassword)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    });
                }))).pipe(operators.mapTo(new ChangePasswordSuccess()), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new ChangePasswordError(error)); })));
            })));
            this.passwordForgotten$ = this.actions$.pipe(effects.ofType(PasswordManagementActionTypes.ResetPasswordRequest), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.exhaustMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.afAuth.auth.sendPasswordResetEmail(payload.email, { url: payload.redirectUrl })).pipe(operators.map(( /**
                 * @param {?} authData
                 * @return {?}
                 */function (authData) {
                    return new ResetPasswordRequestSuccess();
                })), operators.catchError(( /**
                 * @param {?} err
                 * @return {?}
                 */function (err) { return rxjs.of(new ResetPasswordRequestError(err)); })));
            })));
        }
        PasswordManagementEffects.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        PasswordManagementEffects.ctorParameters = function () {
            return [
                { type: effects.Actions },
                { type: auth$1.AngularFireAuth }
            ];
        };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], PasswordManagementEffects.prototype, "changePassword", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", Object)
        ], PasswordManagementEffects.prototype, "passwordForgotten$", void 0);
        return PasswordManagementEffects;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomEmailHandlerEffects = /** @class */ (function () {
        function CustomEmailHandlerEffects(actions$, afAuth) {
            var _this = this;
            this.actions$ = actions$;
            this.afAuth = afAuth;
            this.verifyEmail = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.VerifyEmailAddress), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.switchMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.afAuth.auth.applyActionCode(payload.actionCode).then(( /**
                 * @param {?} res
                 * @return {?}
                 */function (res) {
                    return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            return [2 /*return*/];
                        });
                    });
                }))).pipe(operators.mapTo(new VerifyEmailAddressSuccess()), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new VerifyEmailAddressError(error)); })));
            })));
            this.verifyPasswordResetCode = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.VerifyPasswordResetCode), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.switchMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.afAuth.auth.verifyPasswordResetCode(payload.actionCode)).pipe(operators.switchMap(( /**
                 * @param {?} email
                 * @return {?}
                 */function (email) {
                    return rxjs.of(new VerifyPasswordResetCodeSuccess({ email: email, actionCode: payload.actionCode }));
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new VerifyPasswordResetCodeError(error)); })));
            })));
            this.resetPassword = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.ResetPassword), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.switchMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.afAuth.auth.confirmPasswordReset(payload.actionCode, payload.newPassword)).pipe(operators.switchMap(( /**
                 * @return {?}
                 */function () {
                    return rxjs.of(new ResetPasswordSuccess());
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new ResetPasswordError(error)); })));
            })));
            this.checkActionCode = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.CheckActionCode), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.switchMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.afAuth.auth.checkActionCode(payload.actionCode)).pipe(operators.map(( /**
                 * @param {?} info
                 * @return {?}
                 */function (info) { return info['data']['email']; })), operators.switchMap(( /**
                 * @param {?} restoredEmail
                 * @return {?}
                 */function (restoredEmail) {
                    return rxjs.of(new CheckActionCodeSuccess({ actionCode: payload.actionCode, restoredEmail: restoredEmail }));
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new CheckActionCodeError(error)); })));
            })));
            this.revertOldEmail = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.RecoverEmail), operators.map(( /**
             * @param {?} action
             * @return {?}
             */function (action) { return action.payload; })), operators.switchMap(( /**
             * @param {?} payload
             * @return {?}
             */function (payload) {
                return rxjs.from(_this.afAuth.auth.applyActionCode(payload.actionCode)).pipe(operators.switchMap(( /**
                 * @return {?}
                 */function () {
                    return rxjs.of(new RecoverEmailSuccess());
                })), operators.catchError(( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return rxjs.of(new RecoverEmailError(error)); })));
            })));
        }
        CustomEmailHandlerEffects.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        CustomEmailHandlerEffects.ctorParameters = function () {
            return [
                { type: effects.Actions },
                { type: auth$1.AngularFireAuth }
            ];
        };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "verifyEmail", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "verifyPasswordResetCode", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "resetPassword", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "checkActionCode", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "revertOldEmail", void 0);
        return CustomEmailHandlerEffects;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FirebaseNgrxUserManagementModule = /** @class */ (function () {
        function FirebaseNgrxUserManagementModule() {
        }
        /**
         * @param {?} config
         * @return {?}
         */
        FirebaseNgrxUserManagementModule.forRoot = /**
         * @param {?} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: FirebaseNgrxUserManagementModule,
                    providers: [
                        {
                            provide: FIREBASE_USER_MANAGEMENT_CONFIG, useValue: config
                        }
                    ]
                };
            };
        FirebaseNgrxUserManagementModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [
                            fire.AngularFireModule,
                            auth$1.AngularFireAuthModule,
                            effects.EffectsModule.forFeature([
                                CustomEmailHandlerEffects,
                                LoginEffects,
                                ReAuthenticationEffects,
                                RegistrationEffects,
                                ProvidersManagementEffects,
                                PasswordManagementEffects
                            ]),
                            store.StoreModule.forFeature('auth', reducers)
                        ],
                        declarations: [],
                        exports: [],
                        providers: []
                    },] }
        ];
        return FirebaseNgrxUserManagementModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.User = User;
    exports.getAuthState = getAuthState;
    exports.isAuthLoading = isAuthLoading;
    exports.PasswordManagementActions = passwordManagement_actions;
    exports.ProvidersManagementActions = providersManagement_actions;
    exports.getChangePasswordStatus = getChangePasswordStatus;
    exports.isUserLogged = isUserLogged;
    exports.getUser = getUser;
    exports.getAuthError = getAuthError;
    exports.isAuthSuccess = isAuthSuccess;
    exports.getUserState = getUserState;
    exports.getUserProvidersState = getUserProvidersState;
    exports.getUserProviders = getUserProviders;
    exports.getProvidersRequestStatus = getProvidersRequestStatus;
    exports.getCustomEmailHandlerRequestStatus = getCustomEmailHandlerRequestStatus;
    exports.isEmailVerifiedLoading = isEmailVerifiedLoading;
    exports.getEmailVerifiedError = getEmailVerifiedError;
    exports.isRecoverEmailLoading = isRecoverEmailLoading;
    exports.isResetPasswordLoading = isResetPasswordLoading;
    exports.isPasswordResetCodeLoading = isPasswordResetCodeLoading;
    exports.isCheckCodeLoading = isCheckCodeLoading;
    exports.getPasswordResetCodeError = getPasswordResetCodeError;
    exports.getRecoverEmailError = getRecoverEmailError;
    exports.getCheckCodeError = getCheckCodeError;
    exports.getResetPasswordError = getResetPasswordError;
    exports.isResetPasswordOrCodeLoading = isResetPasswordOrCodeLoading;
    exports.getResetPasswordOrCodeError = getResetPasswordOrCodeError;
    exports.getRecoverEmailOrCheckCodeError = getRecoverEmailOrCheckCodeError;
    exports.isRecoverEmailOrCheckCodeLoading = isRecoverEmailOrCheckCodeLoading;
    exports.getPasswordResetCodeEmail = getPasswordResetCodeEmail;
    exports.getResetPasswordSuccess = getResetPasswordSuccess;
    exports.AuthActions = auth_actions;
    exports.CustomEmailHandlerActions = customEmailHandler_actions;
    exports.getEmailVerifiedStatus = getEmailVerifiedStatus;
    exports.getVerifyResetPasswordProcedure = getVerifyResetPasswordProcedure;
    exports.getPasswordResetStatus = getPasswordResetStatus;
    exports.FirebaseNgrxUserManagementService = FirebaseNgrxUserManagementService;
    exports.FirebaseNgrxUserManagementModule = FirebaseNgrxUserManagementModule;
    exports.ɵg = FIREBASE_USER_MANAGEMENT_CONFIG;
    exports.ɵd = CustomEmailHandlerEffects;
    exports.ɵe = LoginEffects;
    exports.ɵk = PasswordManagementEffects;
    exports.ɵj = ProvidersManagementEffects;
    exports.ɵh = ReAuthenticationEffects;
    exports.ɵi = RegistrationEffects;
    exports.ɵm = reducer$3;
    exports.ɵa = reducers;
    exports.ɵl = reducer$1;
    exports.ɵc = reducer$2;
    exports.ɵb = reducer;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=xtream-ionic-firebase-ngrx-user-management.umd.js.map