import { Actions } from '@ngrx/effects';
import { AngularFireAuth } from '@angular/fire/auth';
import { Observable } from 'rxjs';
import { Action } from '@ngrx/store';
import 'firebase/auth';
import * as PasswordActions from '../actions/password-management.actions';
export declare class PasswordManagementEffects {
    private actions$;
    private afAuth;
    changePassword: Observable<Action>;
    passwordForgotten$: Observable<PasswordActions.ResetPasswordRequestError | PasswordActions.ResetPasswordRequestSuccess>;
    constructor(actions$: Actions, afAuth: AngularFireAuth);
}
