import { Actions } from '@ngrx/effects';
import { Observable } from 'rxjs';
import { Action } from '@ngrx/store';
import { AngularFireAuth } from '@angular/fire/auth';
import 'firebase/auth';
export declare class ProvidersManagementEffects {
    private actions$;
    private afAuth;
    linkToGoogleAccount$: Observable<Action>;
    linkToFacebookAccount$: Observable<Action>;
    linkToCredentialsAccount$: Observable<Action>;
    unlinkGoogleAccount$: Observable<Action>;
    unlinkFacebookAccount$: Observable<Action>;
    unlinkCredentialsAccount$: Observable<Action>;
    unlinkPhone$: Observable<Action>;
    sendCodeToPhone$: Observable<Action>;
    verifyCode$: Observable<Action>;
    private phoneNumberConfirmation;
    private doLinkToGoogleProvider;
    private doUnlinkToGoogleProvider;
    private doLinkToFacebookProvider;
    private doUnlinkToFacebookProvider;
    private doUnlinkPhoneNumber;
    private doLinkToCredentials;
    private doUnlinkToCredentials;
    private doFacebookReAuthentication;
    private doFacebookReAuthenticationWithRedirect;
    private reAuthenticate;
    private reAuthenticateWithRedirect;
    private doGoogleReAuthentication;
    private doGoogleReAuthenticationWithRedirect;
    constructor(actions$: Actions, afAuth: AngularFireAuth);
}
