import { ProvidersManagementActions } from '../actions';
export interface State {
    loading: boolean;
    success: boolean;
    providers: {
        facebook: boolean;
        google: boolean;
        phone: boolean;
        password: boolean;
    };
    error: {
        code: string;
        message: string;
    };
}
export declare function reducer(state: State, action: ProvidersManagementActions.ProvidersManagementActionsUnion): State;
