import { AuthActions, CustomEmailHandlerActions, ProvidersManagementActions } from '../actions';
import { User } from '../models/auth.model';
export declare type Action = AuthActions.AuthActionsUnion | ProvidersManagementActions.ProvidersManagementActionsUnion | CustomEmailHandlerActions.CustomEmailHandlerActionsUnion;
export interface State {
    loggedIn: boolean;
    user: User | null;
    loading: boolean;
    error: {
        code: string;
        message: string;
    };
    success: boolean;
}
export declare function reducer(state: State, action: Action): State;
