(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@ngrx/store'), require('@angular/core'), require('@ngrx/effects'), require('@angular/fire/auth'), require('rxjs/operators'), require('rxjs'), require('firebase/app'), require('firebase/auth'), require('@angular/fire')) :
    typeof define === 'function' && define.amd ? define('@xtream/firebase-ngrx-user-management', ['exports', '@ngrx/store', '@angular/core', '@ngrx/effects', '@angular/fire/auth', 'rxjs/operators', 'rxjs', 'firebase/app', 'firebase/auth', '@angular/fire'], factory) :
    (global = global || self, factory((global.xtream = global.xtream || {}, global.xtream['firebase-ngrx-user-management'] = {}), global.store, global.ng.core, global.effects, global.ng.fire.auth, global.rxjs.operators, global.rxjs, global.app, null, global.ng.fire));
}(this, function (exports, store, core, effects, auth, operators, rxjs, app, auth$1, fire) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function IUser() { }
    if (false) {
        /** @type {?|undefined} */
        IUser.prototype.uid;
        /** @type {?} */
        IUser.prototype.displayName;
        /** @type {?} */
        IUser.prototype.email;
        /** @type {?|undefined} */
        IUser.prototype.photoURL;
        /** @type {?} */
        IUser.prototype.phoneNumber;
        /** @type {?|undefined} */
        IUser.prototype.emailVerified;
    }
    var User = /** @class */ (function () {
        function User(uid, displayName, email, phoneNumber, photoURL, emailVerified) {
            this.uid = uid;
            this.displayName = displayName;
            this.email = email;
            this.phoneNumber = phoneNumber;
            this.photoURL = photoURL;
            this.emailVerified = emailVerified;
        }
        return User;
    }());
    if (false) {
        /** @type {?} */
        User.prototype.uid;
        /** @type {?} */
        User.prototype.displayName;
        /** @type {?} */
        User.prototype.email;
        /** @type {?} */
        User.prototype.phoneNumber;
        /** @type {?} */
        User.prototype.photoURL;
        /** @type {?} */
        User.prototype.emailVerified;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var CustomEmailHandlerActionTypes = {
        CheckActionCode: '[Auth/CustomEmailHandler] Check Action Code',
        CheckActionCodeError: '[Auth/CustomEmailHandler] Check Action Code Error',
        CheckActionCodeSuccess: '[Auth/CustomEmailHandler] Check Action Code Success',
        RecoverEmail: '[Auth/CustomEmailHandler] Recover Email',
        RecoverEmailSuccess: '[Auth/CustomEmailHandler] Recover Email Success',
        RecoverEmailError: '[Auth/CustomEmailHandler] Recover Email Error',
        ResetPassword: '[Auth/CustomEmailHandler] Reset Password',
        ResetPasswordSuccess: '[Auth/CustomEmailHandler] Reset Password Success',
        ResetPasswordError: '[Auth/CustomEmailHandler] Reset Password Error',
        VerifyEmailAddress: '[Auth/CustomEmailHandler] Verify Email Address',
        VerifyEmailAddressSuccess: '[Auth/CustomEmailHandler] Verify Email Address Success',
        VerifyEmailAddressError: '[Auth/CustomEmailHandler] Verify Email Address Error',
        VerifyPasswordResetCode: '[Auth/CustomEmailHandler] Verify Password Reset Code',
        VerifyPasswordResetCodeError: '[Auth/CustomEmailHandler] Verify Password Reset Error',
        VerifyPasswordResetCodeSuccess: '[Auth/CustomEmailHandler] Verify Password Reset Success',
    };
    var CheckActionCode = /** @class */ (function () {
        function CheckActionCode(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.CheckActionCode;
        }
        return CheckActionCode;
    }());
    if (false) {
        /** @type {?} */
        CheckActionCode.prototype.type;
        /** @type {?} */
        CheckActionCode.prototype.payload;
    }
    var CheckActionCodeError = /** @class */ (function () {
        function CheckActionCodeError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.CheckActionCodeError;
        }
        return CheckActionCodeError;
    }());
    if (false) {
        /** @type {?} */
        CheckActionCodeError.prototype.type;
        /** @type {?} */
        CheckActionCodeError.prototype.payload;
    }
    var CheckActionCodeSuccess = /** @class */ (function () {
        function CheckActionCodeSuccess(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.CheckActionCodeSuccess;
        }
        return CheckActionCodeSuccess;
    }());
    if (false) {
        /** @type {?} */
        CheckActionCodeSuccess.prototype.type;
        /** @type {?} */
        CheckActionCodeSuccess.prototype.payload;
    }
    var RecoverEmail = /** @class */ (function () {
        function RecoverEmail(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.RecoverEmail;
        }
        return RecoverEmail;
    }());
    if (false) {
        /** @type {?} */
        RecoverEmail.prototype.type;
        /** @type {?} */
        RecoverEmail.prototype.payload;
    }
    var RecoverEmailError = /** @class */ (function () {
        function RecoverEmailError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.RecoverEmailError;
        }
        return RecoverEmailError;
    }());
    if (false) {
        /** @type {?} */
        RecoverEmailError.prototype.type;
        /** @type {?} */
        RecoverEmailError.prototype.payload;
    }
    var RecoverEmailSuccess = /** @class */ (function () {
        function RecoverEmailSuccess() {
            this.type = CustomEmailHandlerActionTypes.RecoverEmailSuccess;
        }
        return RecoverEmailSuccess;
    }());
    if (false) {
        /** @type {?} */
        RecoverEmailSuccess.prototype.type;
    }
    var ResetPassword = /** @class */ (function () {
        function ResetPassword(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.ResetPassword;
        }
        return ResetPassword;
    }());
    if (false) {
        /** @type {?} */
        ResetPassword.prototype.type;
        /** @type {?} */
        ResetPassword.prototype.payload;
    }
    var ResetPasswordError = /** @class */ (function () {
        function ResetPasswordError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.ResetPasswordError;
        }
        return ResetPasswordError;
    }());
    if (false) {
        /** @type {?} */
        ResetPasswordError.prototype.type;
        /** @type {?} */
        ResetPasswordError.prototype.payload;
    }
    var ResetPasswordSuccess = /** @class */ (function () {
        function ResetPasswordSuccess() {
            this.type = CustomEmailHandlerActionTypes.ResetPasswordSuccess;
        }
        return ResetPasswordSuccess;
    }());
    if (false) {
        /** @type {?} */
        ResetPasswordSuccess.prototype.type;
    }
    var VerifyEmailAddress = /** @class */ (function () {
        function VerifyEmailAddress(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyEmailAddress;
        }
        return VerifyEmailAddress;
    }());
    if (false) {
        /** @type {?} */
        VerifyEmailAddress.prototype.type;
        /** @type {?} */
        VerifyEmailAddress.prototype.payload;
    }
    var VerifyEmailAddressError = /** @class */ (function () {
        function VerifyEmailAddressError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyEmailAddressError;
        }
        return VerifyEmailAddressError;
    }());
    if (false) {
        /** @type {?} */
        VerifyEmailAddressError.prototype.type;
        /** @type {?} */
        VerifyEmailAddressError.prototype.payload;
    }
    var VerifyEmailAddressSuccess = /** @class */ (function () {
        function VerifyEmailAddressSuccess() {
            this.type = CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess;
        }
        return VerifyEmailAddressSuccess;
    }());
    if (false) {
        /** @type {?} */
        VerifyEmailAddressSuccess.prototype.type;
    }
    var VerifyPasswordResetCode = /** @class */ (function () {
        function VerifyPasswordResetCode(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCode;
        }
        return VerifyPasswordResetCode;
    }());
    if (false) {
        /** @type {?} */
        VerifyPasswordResetCode.prototype.type;
        /** @type {?} */
        VerifyPasswordResetCode.prototype.payload;
    }
    var VerifyPasswordResetCodeError = /** @class */ (function () {
        function VerifyPasswordResetCodeError(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeError;
        }
        return VerifyPasswordResetCodeError;
    }());
    if (false) {
        /** @type {?} */
        VerifyPasswordResetCodeError.prototype.type;
        /** @type {?} */
        VerifyPasswordResetCodeError.prototype.payload;
    }
    var VerifyPasswordResetCodeSuccess = /** @class */ (function () {
        function VerifyPasswordResetCodeSuccess(payload) {
            this.payload = payload;
            this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeSuccess;
        }
        return VerifyPasswordResetCodeSuccess;
    }());
    if (false) {
        /** @type {?} */
        VerifyPasswordResetCodeSuccess.prototype.type;
        /** @type {?} */
        VerifyPasswordResetCodeSuccess.prototype.payload;
    }

    var customEmailHandler_actions = /*#__PURE__*/Object.freeze({
        CustomEmailHandlerActionTypes: CustomEmailHandlerActionTypes,
        CheckActionCode: CheckActionCode,
        CheckActionCodeError: CheckActionCodeError,
        CheckActionCodeSuccess: CheckActionCodeSuccess,
        RecoverEmail: RecoverEmail,
        RecoverEmailError: RecoverEmailError,
        RecoverEmailSuccess: RecoverEmailSuccess,
        ResetPassword: ResetPassword,
        ResetPasswordError: ResetPasswordError,
        ResetPasswordSuccess: ResetPasswordSuccess,
        VerifyEmailAddress: VerifyEmailAddress,
        VerifyEmailAddressError: VerifyEmailAddressError,
        VerifyEmailAddressSuccess: VerifyEmailAddressSuccess,
        VerifyPasswordResetCode: VerifyPasswordResetCode,
        VerifyPasswordResetCodeError: VerifyPasswordResetCodeError,
        VerifyPasswordResetCodeSuccess: VerifyPasswordResetCodeSuccess
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var PasswordManagementActionTypes = {
        ChangePasswordRequest: '[Auth/Password] Change Password Request',
        ChangePasswordError: '[Auth/Password] Change Password Error',
        ChangePasswordSuccess: '[Auth/Password] Change Password Success',
        ResetPasswordStatus: '[Auth/Password] Reset Change Password Status',
        ResetPasswordRequest: '[Auth/Password] Reset Password Request',
        ResetPasswordRequestError: '[Auth/Password] Reset Password Request Error',
        ResetPasswordRequestSuccess: '[Auth/Password] Reset Password Request Success',
    };
    var ChangePasswordRequest = /** @class */ (function () {
        function ChangePasswordRequest(payload) {
            this.payload = payload;
            this.type = PasswordManagementActionTypes.ChangePasswordRequest;
        }
        return ChangePasswordRequest;
    }());
    if (false) {
        /** @type {?} */
        ChangePasswordRequest.prototype.type;
        /** @type {?} */
        ChangePasswordRequest.prototype.payload;
    }
    var ChangePasswordError = /** @class */ (function () {
        function ChangePasswordError(payload) {
            this.payload = payload;
            this.type = PasswordManagementActionTypes.ChangePasswordError;
        }
        return ChangePasswordError;
    }());
    if (false) {
        /** @type {?} */
        ChangePasswordError.prototype.type;
        /** @type {?} */
        ChangePasswordError.prototype.payload;
    }
    var ChangePasswordSuccess = /** @class */ (function () {
        function ChangePasswordSuccess() {
            this.type = PasswordManagementActionTypes.ChangePasswordSuccess;
        }
        return ChangePasswordSuccess;
    }());
    if (false) {
        /** @type {?} */
        ChangePasswordSuccess.prototype.type;
    }
    var ResetPasswordStatus = /** @class */ (function () {
        function ResetPasswordStatus() {
            this.type = PasswordManagementActionTypes.ResetPasswordStatus;
        }
        return ResetPasswordStatus;
    }());
    if (false) {
        /** @type {?} */
        ResetPasswordStatus.prototype.type;
    }
    var ResetPasswordRequest = /** @class */ (function () {
        function ResetPasswordRequest(payload) {
            this.payload = payload;
            this.type = PasswordManagementActionTypes.ResetPasswordRequest;
        }
        return ResetPasswordRequest;
    }());
    if (false) {
        /** @type {?} */
        ResetPasswordRequest.prototype.type;
        /** @type {?} */
        ResetPasswordRequest.prototype.payload;
    }
    var ResetPasswordRequestError = /** @class */ (function () {
        function ResetPasswordRequestError(payload) {
            this.payload = payload;
            this.type = PasswordManagementActionTypes.ResetPasswordRequestError;
        }
        return ResetPasswordRequestError;
    }());
    if (false) {
        /** @type {?} */
        ResetPasswordRequestError.prototype.type;
        /** @type {?} */
        ResetPasswordRequestError.prototype.payload;
    }
    var ResetPasswordRequestSuccess = /** @class */ (function () {
        function ResetPasswordRequestSuccess() {
            this.type = PasswordManagementActionTypes.ResetPasswordRequestSuccess;
        }
        return ResetPasswordRequestSuccess;
    }());
    if (false) {
        /** @type {?} */
        ResetPasswordRequestSuccess.prototype.type;
    }

    var passwordManagement_actions = /*#__PURE__*/Object.freeze({
        PasswordManagementActionTypes: PasswordManagementActionTypes,
        ChangePasswordRequest: ChangePasswordRequest,
        ChangePasswordError: ChangePasswordError,
        ChangePasswordSuccess: ChangePasswordSuccess,
        ResetPasswordStatus: ResetPasswordStatus,
        ResetPasswordRequest: ResetPasswordRequest,
        ResetPasswordRequestError: ResetPasswordRequestError,
        ResetPasswordRequestSuccess: ResetPasswordRequestSuccess
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var ProvidersManagementActionTypes = {
        CodeSent: '[Auth/Providers] Code Sent',
        LinkCredentialAccount: '[Auth/Providers] Link Credential Account',
        LinkFacebookAccount: '[Auth/Providers] Link Facebook Account',
        LinkGoogleAccount: '[Auth/Providers] Link Google Account',
        LinkError: '[Auth/Providers] Link Error',
        LinkSuccess: '[Auth/Providers] Link Success',
        SetProviders: '[Auth/Providers] Set Providers',
        UnlinkCredentialAccount: '[Auth/Providers] Unlink Credential Account',
        UnlinkFacebookAccount: '[Auth/Providers] Unlink Facebook Account',
        UnlinkGoogleAccount: '[Auth/Providers] Unlink Google Account',
        UnlinkError: '[Auth/Providers] Unlink Error',
        UnlinkSuccess: '[Auth/Providers] Unlink Success',
        SendPhoneNumberCode: '[Auth] Send Phone Number Code',
        UnlinkPhoneNumber: '[Auth] Unlink Phone Number',
        VerifyPhoneNumber: '[Auth] Verify Phone',
    };
    var LinkCredentialAccount = /** @class */ (function () {
        function LinkCredentialAccount(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.LinkCredentialAccount;
        }
        return LinkCredentialAccount;
    }());
    if (false) {
        /** @type {?} */
        LinkCredentialAccount.prototype.type;
        /** @type {?} */
        LinkCredentialAccount.prototype.payload;
    }
    var LinkFacebookAccount = /** @class */ (function () {
        function LinkFacebookAccount() {
            this.type = ProvidersManagementActionTypes.LinkFacebookAccount;
        }
        return LinkFacebookAccount;
    }());
    if (false) {
        /** @type {?} */
        LinkFacebookAccount.prototype.type;
    }
    var LinkGoogleAccount = /** @class */ (function () {
        function LinkGoogleAccount() {
            this.type = ProvidersManagementActionTypes.LinkGoogleAccount;
        }
        return LinkGoogleAccount;
    }());
    if (false) {
        /** @type {?} */
        LinkGoogleAccount.prototype.type;
    }
    var VerifyPhoneNumber = /** @class */ (function () {
        function VerifyPhoneNumber(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.VerifyPhoneNumber;
        }
        return VerifyPhoneNumber;
    }());
    if (false) {
        /** @type {?} */
        VerifyPhoneNumber.prototype.type;
        /** @type {?} */
        VerifyPhoneNumber.prototype.payload;
    }
    var LinkSuccess = /** @class */ (function () {
        function LinkSuccess(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.LinkSuccess;
        }
        return LinkSuccess;
    }());
    if (false) {
        /** @type {?} */
        LinkSuccess.prototype.type;
        /** @type {?} */
        LinkSuccess.prototype.payload;
    }
    var LinkError = /** @class */ (function () {
        function LinkError(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.LinkError;
        }
        return LinkError;
    }());
    if (false) {
        /** @type {?} */
        LinkError.prototype.type;
        /** @type {?} */
        LinkError.prototype.payload;
    }
    var UnlinkSuccess = /** @class */ (function () {
        function UnlinkSuccess(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.UnlinkSuccess;
        }
        return UnlinkSuccess;
    }());
    if (false) {
        /** @type {?} */
        UnlinkSuccess.prototype.type;
        /** @type {?} */
        UnlinkSuccess.prototype.payload;
    }
    var UnlinkError = /** @class */ (function () {
        function UnlinkError(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.UnlinkError;
        }
        return UnlinkError;
    }());
    if (false) {
        /** @type {?} */
        UnlinkError.prototype.type;
        /** @type {?} */
        UnlinkError.prototype.payload;
    }
    var SendPhoneNumberCode = /** @class */ (function () {
        function SendPhoneNumberCode(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.SendPhoneNumberCode;
        }
        return SendPhoneNumberCode;
    }());
    if (false) {
        /** @type {?} */
        SendPhoneNumberCode.prototype.type;
        /** @type {?} */
        SendPhoneNumberCode.prototype.payload;
    }
    var UnlinkFacebookAccount = /** @class */ (function () {
        function UnlinkFacebookAccount() {
            this.type = ProvidersManagementActionTypes.UnlinkFacebookAccount;
        }
        return UnlinkFacebookAccount;
    }());
    if (false) {
        /** @type {?} */
        UnlinkFacebookAccount.prototype.type;
    }
    var UnlinkGoogleAccount = /** @class */ (function () {
        function UnlinkGoogleAccount() {
            this.type = ProvidersManagementActionTypes.UnlinkGoogleAccount;
        }
        return UnlinkGoogleAccount;
    }());
    if (false) {
        /** @type {?} */
        UnlinkGoogleAccount.prototype.type;
    }
    var UnlinkCredentialAccount = /** @class */ (function () {
        function UnlinkCredentialAccount() {
            this.type = ProvidersManagementActionTypes.UnlinkCredentialAccount;
        }
        return UnlinkCredentialAccount;
    }());
    if (false) {
        /** @type {?} */
        UnlinkCredentialAccount.prototype.type;
    }
    var SetProviders = /** @class */ (function () {
        function SetProviders(payload) {
            this.payload = payload;
            this.type = ProvidersManagementActionTypes.SetProviders;
        }
        return SetProviders;
    }());
    if (false) {
        /** @type {?} */
        SetProviders.prototype.type;
        /** @type {?} */
        SetProviders.prototype.payload;
    }
    var CodeSent = /** @class */ (function () {
        function CodeSent() {
            this.type = ProvidersManagementActionTypes.CodeSent;
        }
        return CodeSent;
    }());
    if (false) {
        /** @type {?} */
        CodeSent.prototype.type;
    }
    var UnlinkPhoneNumber = /** @class */ (function () {
        function UnlinkPhoneNumber() {
            this.type = ProvidersManagementActionTypes.UnlinkPhoneNumber;
        }
        return UnlinkPhoneNumber;
    }());
    if (false) {
        /** @type {?} */
        UnlinkPhoneNumber.prototype.type;
    }

    var providersManagement_actions = /*#__PURE__*/Object.freeze({
        ProvidersManagementActionTypes: ProvidersManagementActionTypes,
        LinkCredentialAccount: LinkCredentialAccount,
        LinkFacebookAccount: LinkFacebookAccount,
        LinkGoogleAccount: LinkGoogleAccount,
        VerifyPhoneNumber: VerifyPhoneNumber,
        LinkSuccess: LinkSuccess,
        LinkError: LinkError,
        UnlinkSuccess: UnlinkSuccess,
        UnlinkError: UnlinkError,
        SendPhoneNumberCode: SendPhoneNumberCode,
        UnlinkFacebookAccount: UnlinkFacebookAccount,
        UnlinkGoogleAccount: UnlinkGoogleAccount,
        UnlinkCredentialAccount: UnlinkCredentialAccount,
        SetProviders: SetProviders,
        CodeSent: CodeSent,
        UnlinkPhoneNumber: UnlinkPhoneNumber
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var AuthActionTypes = {
        Authenticated: '[Auth] Authenticated',
        AuthError: '[Auth] Error',
        CredentialsLogin: '[Auth] Credentials Login Attempt',
        CredentialsReAuthentication: '[Auth] Credentials ReAuthentication attempt',
        CredentialsRegistration: '[Auth] Credentials Registration Attempt',
        DeleteAccount: '[Auth] Delete Account',
        DeleteAccountSuccess: '[Auth] Delete Account Success',
        DeleteAccountError: '[Auth] Delete Account Error',
        FacebookLogin: '[Auth] Facebook Login Attempt',
        FacebookReAuthentication: '[Auth] Facebook ReAuthentication Attempt',
        FacebookRegistration: '[Auth] Facebook Registration Attempt',
        GetUser: '[Auth] Get User',
        GoogleLogin: '[Auth] Google Login Attempt',
        GoogleReAuthentication: '[Auth] Google ReAuthentication Attempt',
        GoogleRegistration: '[Auth] Google Registration Attempt',
        Logout: '[Auth] Logout',
        NotAuthenticated: '[Auth] Not Authenticated',
        SendVerificationEmail: '[Auth] Send Verification Email',
        ReAuthenticationError: '[Auth] ReAuthentication Error',
        ReAuthenticationSuccess: '[Auth] ReAuthentication Success',
        RefreshToken: '[Auth] ReFresh Token',
        RegistrationSuccess: '[Auth] Registration Success',
        ResetAuthState: '[Auth] Reset State',
        VerificationEmailError: '[Auth] Verification Email Error',
        VerificationEmailSent: '[Auth] Verification Email Sent',
    };
    var GetUser = /** @class */ (function () {
        function GetUser(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.GetUser;
        }
        return GetUser;
    }());
    if (false) {
        /** @type {?} */
        GetUser.prototype.type;
        /** @type {?} */
        GetUser.prototype.payload;
    }
    var Authenticated = /** @class */ (function () {
        function Authenticated(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.Authenticated;
        }
        return Authenticated;
    }());
    if (false) {
        /** @type {?} */
        Authenticated.prototype.type;
        /** @type {?} */
        Authenticated.prototype.payload;
    }
    var NotAuthenticated = /** @class */ (function () {
        function NotAuthenticated(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.NotAuthenticated;
        }
        return NotAuthenticated;
    }());
    if (false) {
        /** @type {?} */
        NotAuthenticated.prototype.type;
        /** @type {?} */
        NotAuthenticated.prototype.payload;
    }
    var AuthError = /** @class */ (function () {
        function AuthError(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.AuthError;
        }
        return AuthError;
    }());
    if (false) {
        /** @type {?} */
        AuthError.prototype.type;
        /** @type {?} */
        AuthError.prototype.payload;
    }
    var GoogleRegistration = /** @class */ (function () {
        function GoogleRegistration(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.GoogleRegistration;
        }
        return GoogleRegistration;
    }());
    if (false) {
        /** @type {?} */
        GoogleRegistration.prototype.type;
        /** @type {?} */
        GoogleRegistration.prototype.payload;
    }
    var FacebookRegistration = /** @class */ (function () {
        function FacebookRegistration(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.FacebookRegistration;
        }
        return FacebookRegistration;
    }());
    if (false) {
        /** @type {?} */
        FacebookRegistration.prototype.type;
        /** @type {?} */
        FacebookRegistration.prototype.payload;
    }
    var CredentialsRegistration = /** @class */ (function () {
        function CredentialsRegistration(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.CredentialsRegistration;
        }
        return CredentialsRegistration;
    }());
    if (false) {
        /** @type {?} */
        CredentialsRegistration.prototype.type;
        /** @type {?} */
        CredentialsRegistration.prototype.payload;
    }
    var RegistrationSuccess = /** @class */ (function () {
        function RegistrationSuccess(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.RegistrationSuccess;
        }
        return RegistrationSuccess;
    }());
    if (false) {
        /** @type {?} */
        RegistrationSuccess.prototype.type;
        /** @type {?} */
        RegistrationSuccess.prototype.payload;
    }
    var Logout = /** @class */ (function () {
        function Logout(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.Logout;
        }
        return Logout;
    }());
    if (false) {
        /** @type {?} */
        Logout.prototype.type;
        /** @type {?} */
        Logout.prototype.payload;
    }
    var GoogleLogin = /** @class */ (function () {
        function GoogleLogin(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.GoogleLogin;
        }
        return GoogleLogin;
    }());
    if (false) {
        /** @type {?} */
        GoogleLogin.prototype.type;
        /** @type {?} */
        GoogleLogin.prototype.payload;
    }
    var FacebookLogin = /** @class */ (function () {
        function FacebookLogin(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.FacebookLogin;
        }
        return FacebookLogin;
    }());
    if (false) {
        /** @type {?} */
        FacebookLogin.prototype.type;
        /** @type {?} */
        FacebookLogin.prototype.payload;
    }
    var CredentialsLogin = /** @class */ (function () {
        function CredentialsLogin(email, password, remember) {
            this.email = email;
            this.password = password;
            this.remember = remember;
            this.type = AuthActionTypes.CredentialsLogin;
        }
        return CredentialsLogin;
    }());
    if (false) {
        /** @type {?} */
        CredentialsLogin.prototype.type;
        /** @type {?} */
        CredentialsLogin.prototype.email;
        /** @type {?} */
        CredentialsLogin.prototype.password;
        /** @type {?} */
        CredentialsLogin.prototype.remember;
    }
    var GoogleReAuthentication = /** @class */ (function () {
        function GoogleReAuthentication(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.GoogleReAuthentication;
        }
        return GoogleReAuthentication;
    }());
    if (false) {
        /** @type {?} */
        GoogleReAuthentication.prototype.type;
        /** @type {?} */
        GoogleReAuthentication.prototype.payload;
    }
    var FacebookReAuthentication = /** @class */ (function () {
        function FacebookReAuthentication(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.FacebookReAuthentication;
        }
        return FacebookReAuthentication;
    }());
    if (false) {
        /** @type {?} */
        FacebookReAuthentication.prototype.type;
        /** @type {?} */
        FacebookReAuthentication.prototype.payload;
    }
    var CredentialsReAuthentication = /** @class */ (function () {
        function CredentialsReAuthentication(email, password, remember) {
            this.email = email;
            this.password = password;
            this.remember = remember;
            this.type = AuthActionTypes.CredentialsReAuthentication;
        }
        return CredentialsReAuthentication;
    }());
    if (false) {
        /** @type {?} */
        CredentialsReAuthentication.prototype.type;
        /** @type {?} */
        CredentialsReAuthentication.prototype.email;
        /** @type {?} */
        CredentialsReAuthentication.prototype.password;
        /** @type {?} */
        CredentialsReAuthentication.prototype.remember;
    }
    var ReAuthenticationSuccess = /** @class */ (function () {
        function ReAuthenticationSuccess() {
            this.type = AuthActionTypes.ReAuthenticationSuccess;
        }
        return ReAuthenticationSuccess;
    }());
    if (false) {
        /** @type {?} */
        ReAuthenticationSuccess.prototype.type;
    }
    var ReAuthenticationError = /** @class */ (function () {
        function ReAuthenticationError(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.ReAuthenticationError;
        }
        return ReAuthenticationError;
    }());
    if (false) {
        /** @type {?} */
        ReAuthenticationError.prototype.type;
        /** @type {?} */
        ReAuthenticationError.prototype.payload;
    }
    var SendVerificationEmail = /** @class */ (function () {
        function SendVerificationEmail(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.SendVerificationEmail;
        }
        return SendVerificationEmail;
    }());
    if (false) {
        /** @type {?} */
        SendVerificationEmail.prototype.type;
        /** @type {?} */
        SendVerificationEmail.prototype.payload;
    }
    var VerificationEmailError = /** @class */ (function () {
        function VerificationEmailError(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.VerificationEmailError;
        }
        return VerificationEmailError;
    }());
    if (false) {
        /** @type {?} */
        VerificationEmailError.prototype.type;
        /** @type {?} */
        VerificationEmailError.prototype.payload;
    }
    var VerificationEmailSent = /** @class */ (function () {
        function VerificationEmailSent() {
            this.type = AuthActionTypes.VerificationEmailSent;
        }
        return VerificationEmailSent;
    }());
    if (false) {
        /** @type {?} */
        VerificationEmailSent.prototype.type;
    }
    var DeleteAccount = /** @class */ (function () {
        function DeleteAccount() {
            this.type = AuthActionTypes.DeleteAccount;
        }
        return DeleteAccount;
    }());
    if (false) {
        /** @type {?} */
        DeleteAccount.prototype.type;
    }
    var DeleteAccountSuccess = /** @class */ (function () {
        function DeleteAccountSuccess() {
            this.type = AuthActionTypes.DeleteAccountSuccess;
        }
        return DeleteAccountSuccess;
    }());
    if (false) {
        /** @type {?} */
        DeleteAccountSuccess.prototype.type;
    }
    var DeleteAccountError = /** @class */ (function () {
        function DeleteAccountError(payload) {
            this.payload = payload;
            this.type = AuthActionTypes.DeleteAccountError;
        }
        return DeleteAccountError;
    }());
    if (false) {
        /** @type {?} */
        DeleteAccountError.prototype.type;
        /** @type {?} */
        DeleteAccountError.prototype.payload;
    }
    var ResetAuthState = /** @class */ (function () {
        function ResetAuthState() {
            this.type = AuthActionTypes.ResetAuthState;
        }
        return ResetAuthState;
    }());
    if (false) {
        /** @type {?} */
        ResetAuthState.prototype.type;
    }
    var RefreshToken = /** @class */ (function () {
        function RefreshToken() {
            this.type = AuthActionTypes.RefreshToken;
        }
        return RefreshToken;
    }());
    if (false) {
        /** @type {?} */
        RefreshToken.prototype.type;
    }

    var auth_actions = /*#__PURE__*/Object.freeze({
        AuthActionTypes: AuthActionTypes,
        GetUser: GetUser,
        Authenticated: Authenticated,
        NotAuthenticated: NotAuthenticated,
        AuthError: AuthError,
        GoogleRegistration: GoogleRegistration,
        FacebookRegistration: FacebookRegistration,
        CredentialsRegistration: CredentialsRegistration,
        RegistrationSuccess: RegistrationSuccess,
        Logout: Logout,
        GoogleLogin: GoogleLogin,
        FacebookLogin: FacebookLogin,
        CredentialsLogin: CredentialsLogin,
        GoogleReAuthentication: GoogleReAuthentication,
        FacebookReAuthentication: FacebookReAuthentication,
        CredentialsReAuthentication: CredentialsReAuthentication,
        ReAuthenticationSuccess: ReAuthenticationSuccess,
        ReAuthenticationError: ReAuthenticationError,
        SendVerificationEmail: SendVerificationEmail,
        VerificationEmailError: VerificationEmailError,
        VerificationEmailSent: VerificationEmailSent,
        DeleteAccount: DeleteAccount,
        DeleteAccountSuccess: DeleteAccountSuccess,
        DeleteAccountError: DeleteAccountError,
        ResetAuthState: ResetAuthState,
        RefreshToken: RefreshToken
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function State() { }
    if (false) {
        /** @type {?} */
        State.prototype.loggedIn;
        /** @type {?} */
        State.prototype.user;
        /** @type {?} */
        State.prototype.loading;
        /** @type {?} */
        State.prototype.error;
        /** @type {?} */
        State.prototype.success;
    }
    /** @type {?} */
    var defaultState = {
        loggedIn: false,
        user: null,
        loading: true,
        error: null,
        success: false
    };
    /// Reducer function
    /**
     * @param {?=} state
     * @param {?=} action
     * @return {?}
     */
    function reducer(state, action) {
        if (state === void 0) { state = defaultState; }
        switch (action.type) {
            case AuthActionTypes.GetUser:
                return __assign({}, state, { loading: true, success: false });
            case AuthActionTypes.Authenticated:
            case AuthActionTypes.RegistrationSuccess:
                return __assign({}, state, { user: action.payload.user, loading: false, loggedIn: true, success: false });
            case AuthActionTypes.NotAuthenticated:
                return __assign({}, state, defaultState, { loading: false, loggedIn: false, success: false });
            case AuthActionTypes.GoogleLogin:
            case AuthActionTypes.FacebookLogin:
            case AuthActionTypes.GoogleRegistration:
            case AuthActionTypes.FacebookRegistration:
            case AuthActionTypes.CredentialsLogin:
            case AuthActionTypes.CredentialsRegistration:
            case AuthActionTypes.FacebookReAuthentication:
            case AuthActionTypes.CredentialsReAuthentication:
            case AuthActionTypes.GoogleReAuthentication:
                return __assign({}, state, { loading: true, success: false });
            case AuthActionTypes.ResetAuthState:
                return __assign({}, state, { loading: false, success: false, error: null });
            case AuthActionTypes.AuthError:
            case AuthActionTypes.ReAuthenticationError:
                return __assign({}, state, { loading: false, success: false, error: action.payload });
            case AuthActionTypes.ReAuthenticationSuccess:
                return __assign({}, state, { loading: false, error: null, success: true });
            case AuthActionTypes.Logout:
                return __assign({}, state, { loading: true });
            case AuthActionTypes.DeleteAccount:
                return __assign({}, state, { loading: true, success: true, error: null });
            case AuthActionTypes.DeleteAccountError:
                return __assign({}, state, { loading: false, success: false, error: action.payload });
            case AuthActionTypes.DeleteAccountSuccess:
                return __assign({}, state, { loading: false, loggedIn: false, success: true, error: null, user: null });
            case CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess:
                return __assign({}, state, { user: __assign({}, state.user, { emailVerified: true }) });
            default:
                return state;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function State$1() { }
    if (false) {
        /** @type {?} */
        State$1.prototype.loading;
        /** @type {?} */
        State$1.prototype.success;
        /** @type {?} */
        State$1.prototype.error;
    }
    /** @type {?} */
    var initialState = (/** @type {?} */ ({
        loading: false,
        success: false,
        error: null
    }));
    /**
     * @param {?=} state
     * @param {?=} action
     * @return {?}
     */
    function reducer$1(state, action) {
        if (state === void 0) { state = initialState; }
        switch (action.type) {
            case PasswordManagementActionTypes.ResetPasswordRequest:
            case PasswordManagementActionTypes.ChangePasswordRequest: {
                return __assign({}, state, { loading: true, success: false, error: null });
            }
            case PasswordManagementActionTypes.ResetPasswordRequestError:
            case PasswordManagementActionTypes.ChangePasswordError: {
                return __assign({}, state, { loading: false, success: false, error: action.payload });
            }
            case PasswordManagementActionTypes.ResetPasswordRequestSuccess:
            case PasswordManagementActionTypes.ChangePasswordSuccess: {
                return __assign({}, state, { loading: false, success: true, error: null });
            }
            case PasswordManagementActionTypes.ResetPasswordStatus: {
                return __assign({}, state, { loading: false, success: false, error: null });
            }
            default:
                return state;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function State$2() { }
    if (false) {
        /** @type {?} */
        State$2.prototype.loading;
        /** @type {?} */
        State$2.prototype.success;
        /** @type {?} */
        State$2.prototype.providers;
        /** @type {?} */
        State$2.prototype.error;
    }
    /** @type {?} */
    var initialState$1 = (/** @type {?} */ ({
        loading: false,
        success: false,
        providers: {
            facebook: false,
            google: false,
            phone: false,
            password: false
        },
        error: null
    }));
    /**
     * @param {?=} state
     * @param {?=} action
     * @return {?}
     */
    function reducer$2(state, action) {
        var _a, _b;
        if (state === void 0) { state = initialState$1; }
        switch (action.type) {
            case ProvidersManagementActionTypes.SetProviders:
                return __assign({}, state, { providers: __assign({}, state.providers, action.payload) });
            case ProvidersManagementActionTypes.LinkCredentialAccount:
            case ProvidersManagementActionTypes.LinkFacebookAccount:
            case ProvidersManagementActionTypes.LinkGoogleAccount:
            case ProvidersManagementActionTypes.UnlinkCredentialAccount:
            case ProvidersManagementActionTypes.UnlinkGoogleAccount:
            case ProvidersManagementActionTypes.UnlinkFacebookAccount:
                return __assign({}, state, { success: false, error: null, loading: true });
            case ProvidersManagementActionTypes.LinkSuccess:
                return __assign({}, state, { providers: __assign({}, state.providers, (_a = {}, _a[action.payload.provider] = true, _a)), success: true, error: null, loading: false });
            case ProvidersManagementActionTypes.UnlinkSuccess:
                return __assign({}, state, { providers: __assign({}, state.providers, (_b = {}, _b[action.payload.provider] = false, _b)), success: true, error: null, loading: false });
            case ProvidersManagementActionTypes.LinkError:
            case ProvidersManagementActionTypes.UnlinkError:
                return __assign({}, state, { success: false, error: action.payload, loading: false });
            default:
                return state;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var initialRequestStatus = {
        loading: false,
        success: false,
        error: null
    };
    /**
     * @record
     */
    function State$3() { }
    if (false) {
        /** @type {?} */
        State$3.prototype.emailVerified;
        /** @type {?} */
        State$3.prototype.passwordResetCode;
        /** @type {?} */
        State$3.prototype.resetPassword;
        /** @type {?} */
        State$3.prototype.checkCode;
        /** @type {?} */
        State$3.prototype.recoverEmail;
    }
    /** @type {?} */
    var initialState$2 = (/** @type {?} */ ({
        emailVerified: __assign({}, initialRequestStatus),
        passwordResetCode: __assign({}, initialRequestStatus),
        resetPassword: __assign({}, initialRequestStatus),
        checkCode: __assign({}, initialRequestStatus),
        recoverEmail: __assign({}, initialRequestStatus)
    }));
    /**
     * @param {?=} state
     * @param {?=} action
     * @return {?}
     */
    function reducer$3(state, action) {
        if (state === void 0) { state = initialState$2; }
        switch (action.type) {
            case CustomEmailHandlerActionTypes.VerifyEmailAddress: {
                return __assign({}, state, { emailVerified: { loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.VerifyEmailAddressError: {
                return __assign({}, state, { emailVerified: { loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess: {
                return __assign({}, state, { emailVerified: { loading: false, success: true, error: null } });
            }
            case CustomEmailHandlerActionTypes.VerifyPasswordResetCode: {
                return __assign({}, state, { passwordResetCode: { email: null, loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.VerifyPasswordResetCodeError: {
                return __assign({}, state, { passwordResetCode: { email: null, loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.VerifyPasswordResetCodeSuccess: {
                return __assign({}, state, { passwordResetCode: { email: action.payload.email, loading: false, success: true, error: null } });
            }
            case CustomEmailHandlerActionTypes.CheckActionCode: {
                return __assign({}, state, { checkCode: { loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.CheckActionCodeError: {
                return __assign({}, state, { checkCode: { loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.CheckActionCodeSuccess: {
                return __assign({}, state, { checkCode: { loading: false, success: true, error: null } });
            }
            case CustomEmailHandlerActionTypes.RecoverEmail: {
                return __assign({}, state, { recoverEmail: { loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.RecoverEmailError: {
                return __assign({}, state, { recoverEmail: { loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.RecoverEmailSuccess: {
                return __assign({}, state, { recoverEmail: { loading: false, success: true, error: null } });
            }
            case CustomEmailHandlerActionTypes.ResetPassword: {
                return __assign({}, state, { resetPassword: { loading: true, success: false, error: null } });
            }
            case CustomEmailHandlerActionTypes.ResetPasswordError: {
                return __assign({}, state, { resetPassword: { loading: false, success: false, error: action.payload } });
            }
            case CustomEmailHandlerActionTypes.ResetPasswordSuccess: {
                return __assign({}, state, { resetPassword: { loading: false, success: true, error: null } });
            }
            default:
                return state;
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function AuthState() { }
    if (false) {
        /** @type {?} */
        AuthState.prototype.user;
        /** @type {?} */
        AuthState.prototype.changePassword;
        /** @type {?} */
        AuthState.prototype.providers;
        /** @type {?} */
        AuthState.prototype.customEmailHandler;
    }
    /** @type {?} */
    var reducers = {
        user: reducer,
        changePassword: reducer$1,
        providers: reducer$2,
        customEmailHandler: reducer$3
    };
    /** @type {?} */
    var getAuthState = store.createFeatureSelector('auth');
    var ɵ0 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.user; };
    /** @type {?} */
    var getUserState = store.createSelector(getAuthState, (ɵ0));
    var ɵ1 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.user.loading; };
    /** @type {?} */
    var isAuthLoading = store.createSelector(getAuthState, (ɵ1));
    var ɵ2 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.user.loggedIn && state.user.user && state.user.user.emailVerified; };
    /** @type {?} */
    var isUserLogged = store.createSelector(getAuthState, (ɵ2));
    var ɵ3 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.user.user; };
    /** @type {?} */
    var getUser = store.createSelector(getAuthState, (ɵ3));
    var ɵ4 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.user.error; };
    /** @type {?} */
    var getAuthError = store.createSelector(getAuthState, (ɵ4));
    var ɵ5 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.user.success; };
    /** @type {?} */
    var isAuthSuccess = store.createSelector(getAuthState, (ɵ5));
    var ɵ6 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.changePassword; };
    /** @type {?} */
    var getChangePasswordStatus = store.createSelector(getAuthState, (ɵ6));
    var ɵ7 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.providers; };
    /** @type {?} */
    var getUserProvidersState = store.createSelector(getAuthState, (ɵ7));
    var ɵ8 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.providers.providers; };
    /** @type {?} */
    var getUserProviders = store.createSelector(getAuthState, (ɵ8));
    var ɵ9 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) {
        return {
            loading: state.providers.loading,
            error: state.providers.error,
            success: state.providers.success
        };
    };
    /** @type {?} */
    var getProvidersRequestStatus = store.createSelector(getAuthState, (ɵ9));
    var ɵ10 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) {
        return {
            emailVerified: {
                loading: state.customEmailHandler.emailVerified.loading,
                error: state.customEmailHandler.emailVerified.error,
                success: state.customEmailHandler.emailVerified.success
            }
        };
    };
    /** @type {?} */
    var getCustomEmailHandlerRequestStatus = store.createSelector(getAuthState, (ɵ10));
    var ɵ11 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.emailVerified; };
    /** @type {?} */
    var getEmailVerifiedStatus = store.createSelector(getAuthState, (ɵ11));
    var ɵ12 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.resetPassword; };
    /** @type {?} */
    var getPasswordResetStatus = store.createSelector(getAuthState, (ɵ12));
    var ɵ13 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.passwordResetCode; };
    /** @type {?} */
    var getVerifyResetPasswordProcedure = store.createSelector(getAuthState, (ɵ13));
    var ɵ14 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.emailVerified.error; };
    /** @type {?} */
    var getEmailVerifiedError = store.createSelector(getAuthState, (ɵ14));
    var ɵ15 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.emailVerified.loading; };
    /** @type {?} */
    var isEmailVerifiedLoading = store.createSelector(getAuthState, (ɵ15));
    var ɵ16 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.passwordResetCode.error; };
    /** @type {?} */
    var getPasswordResetCodeError = store.createSelector(getAuthState, (ɵ16));
    var ɵ17 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.passwordResetCode.loading; };
    /** @type {?} */
    var isPasswordResetCodeLoading = store.createSelector(getAuthState, (ɵ17));
    var ɵ18 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.passwordResetCode.email; };
    /** @type {?} */
    var getPasswordResetCodeEmail = store.createSelector(getAuthState, (ɵ18));
    var ɵ19 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.resetPassword.error; };
    /** @type {?} */
    var getResetPasswordError = store.createSelector(getAuthState, (ɵ19));
    var ɵ20 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.resetPassword.loading; };
    /** @type {?} */
    var isResetPasswordLoading = store.createSelector(getAuthState, (ɵ20));
    var ɵ21 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.checkCode.error; };
    /** @type {?} */
    var getCheckCodeError = store.createSelector(getAuthState, (ɵ21));
    var ɵ22 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.checkCode.loading; };
    /** @type {?} */
    var isCheckCodeLoading = store.createSelector(getAuthState, (ɵ22));
    var ɵ23 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.recoverEmail.error; };
    /** @type {?} */
    var getRecoverEmailError = store.createSelector(getAuthState, (ɵ23));
    var ɵ24 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.recoverEmail.loading; };
    /** @type {?} */
    var isRecoverEmailLoading = store.createSelector(getAuthState, (ɵ24));
    var ɵ25 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.resetPassword.error || state.customEmailHandler.passwordResetCode.error; };
    /** @type {?} */
    var getResetPasswordOrCodeError = store.createSelector(getAuthState, (ɵ25));
    var ɵ26 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.resetPassword.success; };
    /** @type {?} */
    var getResetPasswordSuccess = store.createSelector(getAuthState, (ɵ26));
    var ɵ27 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.resetPassword.loading || state.customEmailHandler.passwordResetCode.loading; };
    /** @type {?} */
    var isResetPasswordOrCodeLoading = store.createSelector(getAuthState, (ɵ27));
    var ɵ28 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.recoverEmail.error || state.customEmailHandler.checkCode.error; };
    /** @type {?} */
    var getRecoverEmailOrCheckCodeError = store.createSelector(getAuthState, (ɵ28));
    var ɵ29 = /**
     * @param {?} state
     * @return {?}
     */
    function (state) { return state.customEmailHandler.recoverEmail.loading || state.customEmailHandler.checkCode.loading; };
    /** @type {?} */
    var isRecoverEmailOrCheckCodeLoading = store.createSelector(getAuthState, (ɵ29));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FirebaseNgrxUserManagementService = /** @class */ (function () {
        function FirebaseNgrxUserManagementService() {
        }
        FirebaseNgrxUserManagementService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        FirebaseNgrxUserManagementService.ctorParameters = function () { return []; };
        /** @nocollapse */ FirebaseNgrxUserManagementService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function FirebaseNgrxUserManagementService_Factory() { return new FirebaseNgrxUserManagementService(); }, token: FirebaseNgrxUserManagementService, providedIn: "root" });
        return FirebaseNgrxUserManagementService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var PROVIDERS_MAP = {};
    PROVIDERS_MAP[app.auth.FacebookAuthProvider.FACEBOOK_SIGN_IN_METHOD] = 'facebook';
    PROVIDERS_MAP[app.auth.GoogleAuthProvider.GOOGLE_SIGN_IN_METHOD] = 'google';
    PROVIDERS_MAP[app.auth.EmailAuthProvider.EMAIL_PASSWORD_SIGN_IN_METHOD] = 'password';
    PROVIDERS_MAP[app.auth.PhoneAuthProvider.PHONE_SIGN_IN_METHOD] = 'phone';
    var LoginEffects = /** @class */ (function () {
        function LoginEffects(actions$, afAuth) {
            var _this = this;
            this.actions$ = actions$;
            this.afAuth = afAuth;
            this.getUser = this.actions$.pipe(effects.ofType(AuthActionTypes.GetUser), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) { return _this.afAuth.authState.pipe(operators.take(1), operators.switchMap((/**
             * @param {?} authData
             * @return {?}
             */
            function (authData) {
                console.debug(authData);
                if (authData) {
                    /// User logged in
                    console.debug('USER', authData);
                    return rxjs.zip(rxjs.from(authData.getIdToken(true))).pipe(operators.switchMap((/**
                     * @param {?} res
                     * @return {?}
                     */
                    function (res) {
                        console.debug('providers found', authData.providerData);
                        /** @type {?} */
                        var providers = authData.providerData.reduce((/**
                         * @param {?} prev
                         * @param {?} current
                         * @return {?}
                         */
                        function (prev, current) {
                            /** @type {?} */
                            var key = PROVIDERS_MAP[current.providerId];
                            if (key) {
                                prev[key] = true;
                            }
                            return prev;
                        }), {});
                        console.debug(providers, authData.providerData.map((/**
                         * @param {?} p
                         * @return {?}
                         */
                        function (p) { return p.providerId; })));
                        /** @type {?} */
                        var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, authData.photoURL, authData.emailVerified);
                        return rxjs.from([new SetProviders(providers), new Authenticated({ user: user })]);
                    })));
                }
                else {
                    return rxjs.of(new NotAuthenticated());
                }
            }))); })));
            this.googleLogin = this.actions$.pipe(effects.ofType(AuthActionTypes.GoogleLogin), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.doGoogleLogin()).pipe(operators.map((/**
                 * @param {?} credential
                 * @return {?}
                 */
                function (credential) {
                    // successful login
                    return new GetUser();
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.facebookLogin = this.actions$.pipe(effects.ofType(AuthActionTypes.FacebookLogin), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.doFacebookLogin()).pipe(operators.map((/**
                 * @param {?} credential
                 * @return {?}
                 */
                function (credential) {
                    // successful login
                    return new GetUser();
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.loginWithCredentials = this.actions$.pipe(effects.ofType(AuthActionTypes.CredentialsLogin), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) {
                return {
                    email: action.email,
                    password: action.password,
                    remember: (action.remember) ? action.remember : false
                };
            })), operators.exhaustMap((/**
             * @param {?} credentials
             * @return {?}
             */
            function (credentials) {
                return rxjs.from(_this.doLoginWithCredentials(credentials)).pipe(operators.map((/**
                 * @param {?} p
                 * @return {?}
                 */
                function (p) {
                    // successful login
                    return new GetUser();
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.logout = this.actions$.pipe(effects.ofType(AuthActionTypes.Logout), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.afAuth.auth.signOut());
            })), operators.map((/**
             * @param {?} authData
             * @return {?}
             */
            function (authData) {
                return new NotAuthenticated();
            })));
            this.onDeleteNotVerifiedAccount$ = this.actions$.pipe(effects.ofType(AuthActionTypes.DeleteAccount), operators.switchMap((/**
             * @return {?}
             */
            function () {
                return rxjs.from(_this.afAuth.auth.currentUser.delete()).pipe(operators.map((/**
                 * @return {?}
                 */
                function () { return new DeleteAccountSuccess(); })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new DeleteAccountError(error)); })));
            })));
            this.refreshToken$ = this.actions$.pipe(effects.ofType(AuthActionTypes.RefreshToken), operators.tap((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return _this.afAuth.auth.currentUser.getIdToken(true); })));
        }
        /**
         * @private
         * @return {?}
         */
        LoginEffects.prototype.doFacebookLogin = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.FacebookAuthProvider();
            return this.afAuth.auth.signInWithPopup(provider);
        };
        /**
         * @private
         * @return {?}
         */
        LoginEffects.prototype.doGoogleLogin = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.GoogleAuthProvider();
            provider.setCustomParameters({
                prompt: 'select_account'
            });
            return this.afAuth.auth.signInWithPopup(provider);
        };
        /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
        LoginEffects.prototype.doLoginWithCredentials = /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
        function (credentials) {
            var _this = this;
            if (credentials.remember) {
                return this.afAuth.auth.setPersistence(app.auth.Auth.Persistence.LOCAL).then((/**
                 * @return {?}
                 */
                function () {
                    return _this.afAuth.auth.signInWithEmailAndPassword(credentials.email, credentials.password);
                }));
            }
            else {
                return this.afAuth.auth.setPersistence(app.auth.Auth.Persistence.SESSION).then((/**
                 * @return {?}
                 */
                function () {
                    return _this.afAuth.auth.signInWithEmailAndPassword(credentials.email, credentials.password);
                }));
            }
        };
        LoginEffects.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        LoginEffects.ctorParameters = function () { return [
            { type: effects.Actions },
            { type: auth.AngularFireAuth }
        ]; };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "getUser", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "googleLogin", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "facebookLogin", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "loginWithCredentials", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "logout", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], LoginEffects.prototype, "onDeleteNotVerifiedAccount$", void 0);
        __decorate([
            effects.Effect({ dispatch: false }),
            __metadata("design:type", Object)
        ], LoginEffects.prototype, "refreshToken$", void 0);
        return LoginEffects;
    }());
    if (false) {
        /** @type {?} */
        LoginEffects.prototype.getUser;
        /** @type {?} */
        LoginEffects.prototype.googleLogin;
        /** @type {?} */
        LoginEffects.prototype.facebookLogin;
        /** @type {?} */
        LoginEffects.prototype.loginWithCredentials;
        /** @type {?} */
        LoginEffects.prototype.logout;
        /** @type {?} */
        LoginEffects.prototype.onDeleteNotVerifiedAccount$;
        /** @type {?} */
        LoginEffects.prototype.refreshToken$;
        /**
         * @type {?}
         * @private
         */
        LoginEffects.prototype.actions$;
        /**
         * @type {?}
         * @private
         */
        LoginEffects.prototype.afAuth;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RegistrationEffects = /** @class */ (function () {
        function RegistrationEffects(actions, afAuth) {
            var _this = this;
            this.actions = actions;
            this.afAuth = afAuth;
            this.googleSignUp = this.actions.pipe(effects.ofType(AuthActionTypes.GoogleRegistration), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.doGoogleRegistration()).pipe(operators.switchMap((/**
                 * @param {?} credential
                 * @return {?}
                 */
                function (credential) {
                    console.debug('credential', credential);
                    /** @type {?} */
                    var authData = credential.user;
                    /** @type {?} */
                    var photoUrl = authData.photoURL;
                    /** @type {?} */
                    var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, photoUrl, authData.emailVerified);
                    return rxjs.from([new SetProviders({ google: true }), new RegistrationSuccess({ user: user })]);
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.facebookSignUp = this.actions.pipe(effects.ofType(AuthActionTypes.FacebookRegistration), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.doFacebookRegistration()).pipe(operators.switchMap((/**
                 * @param {?} credential
                 * @return {?}
                 */
                function (credential) {
                    console.debug('facebookSignUp', credential);
                    /** @type {?} */
                    var authData = credential.user;
                    /** @type {?} */
                    var photoUrl = authData.photoURL;
                    console.log('PhotoUrl', photoUrl);
                    /** @type {?} */
                    var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, photoUrl, authData.emailVerified);
                    return rxjs.from([new SetProviders({ facebook: true }), new RegistrationSuccess({ user: user })]);
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.signUpWithCredentials = this.actions.pipe(effects.ofType(AuthActionTypes.CredentialsRegistration), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) {
                return {
                    email: action.payload.email,
                    password: action.payload.password
                };
            })), operators.exhaustMap((/**
             * @param {?} credentials
             * @return {?}
             */
            function (credentials) {
                return rxjs.from(_this.doSignUpWithCredentials(credentials)).pipe(operators.map((/**
                 * @param {?} credential
                 * @return {?}
                 */
                function (credential) {
                    console.debug('doSignUpWithCredentials', credential);
                    /** @type {?} */
                    var authData = credential.user;
                    /** @type {?} */
                    var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, authData.photoURL, authData.emailVerified);
                    return new RegistrationSuccess({ user: user });
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new AuthError(error)); })));
            })));
            this.sendVerificationEmail$ = this.actions.pipe(effects.ofType(AuthActionTypes.SendVerificationEmail), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.afAuth.auth.currentUser.sendEmailVerification({ url: payload.redirectUrl })).pipe(operators.map((/**
                 * @param {?} p
                 * @return {?}
                 */
                function (p) {
                    return new VerificationEmailSent();
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new VerificationEmailError(error)); })));
            })));
        }
        /**
         * @private
         * @return {?}
         */
        RegistrationEffects.prototype.doFacebookRegistration = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.FacebookAuthProvider();
            return this.afAuth.auth.signInWithPopup(provider);
        };
        /**
         * @private
         * @return {?}
         */
        RegistrationEffects.prototype.doGoogleRegistration = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.GoogleAuthProvider();
            provider.setCustomParameters({
                prompt: 'select_account'
            });
            return this.afAuth.auth.signInWithPopup(provider);
        };
        /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
        RegistrationEffects.prototype.doSignUpWithCredentials = /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
        function (credentials) {
            return this.afAuth.auth.createUserWithEmailAndPassword(credentials.email, credentials.password);
        };
        RegistrationEffects.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        RegistrationEffects.ctorParameters = function () { return [
            { type: effects.Actions },
            { type: auth.AngularFireAuth }
        ]; };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], RegistrationEffects.prototype, "googleSignUp", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], RegistrationEffects.prototype, "facebookSignUp", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], RegistrationEffects.prototype, "signUpWithCredentials", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], RegistrationEffects.prototype, "sendVerificationEmail$", void 0);
        return RegistrationEffects;
    }());
    if (false) {
        /** @type {?} */
        RegistrationEffects.prototype.googleSignUp;
        /** @type {?} */
        RegistrationEffects.prototype.facebookSignUp;
        /** @type {?} */
        RegistrationEffects.prototype.signUpWithCredentials;
        /** @type {?} */
        RegistrationEffects.prototype.sendVerificationEmail$;
        /**
         * @type {?}
         * @private
         */
        RegistrationEffects.prototype.actions;
        /**
         * @type {?}
         * @private
         */
        RegistrationEffects.prototype.afAuth;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ReAuthenticationEffects = /** @class */ (function () {
        function ReAuthenticationEffects(actions, afAuth) {
            var _this = this;
            this.actions = actions;
            this.afAuth = afAuth;
            this.googleReAuthentication = this.actions.pipe(effects.ofType(AuthActionTypes.GoogleReAuthentication), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.doGoogleReAuthentication()).pipe(operators.map((/**
                 * @param {?} credential
                 * @return {?}
                 */
                function (credential) {
                    // successful login
                    return new ReAuthenticationSuccess();
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new ReAuthenticationError(error)); })));
            })));
            this.facebookReAuthentication = this.actions.pipe(effects.ofType(AuthActionTypes.FacebookReAuthentication), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.doFacebookReAuthentication()).pipe(operators.map((/**
                 * @param {?} credential
                 * @return {?}
                 */
                function (credential) {
                    // successful login
                    return new ReAuthenticationSuccess();
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new ReAuthenticationError(error)); })));
            })));
            this.reAuthenticateWithCredentials = this.actions.pipe(effects.ofType(AuthActionTypes.CredentialsReAuthentication), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) {
                return {
                    email: action.email,
                    password: action.password
                };
            })), operators.exhaustMap((/**
             * @param {?} credentials
             * @return {?}
             */
            function (credentials) {
                return rxjs.from(_this.doReAuthenticationWithCredentials(credentials)).pipe(operators.map((/**
                 * @param {?} p
                 * @return {?}
                 */
                function (p) {
                    // successful login
                    return new ReAuthenticationSuccess();
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new ReAuthenticationError(error)); })));
            })));
        }
        /**
         * @private
         * @return {?}
         */
        ReAuthenticationEffects.prototype.doFacebookReAuthentication = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.FacebookAuthProvider();
            return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
        };
        /**
         * @private
         * @return {?}
         */
        ReAuthenticationEffects.prototype.doGoogleReAuthentication = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.GoogleAuthProvider();
            return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
        };
        /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
        ReAuthenticationEffects.prototype.doReAuthenticationWithCredentials = /**
         * @private
         * @param {?} credentials
         * @return {?}
         */
        function (credentials) {
            /** @type {?} */
            var credential = app.auth.EmailAuthProvider.credential(credentials.email, credentials.password);
            return this.afAuth.auth.currentUser.reauthenticateAndRetrieveDataWithCredential(credential);
        };
        ReAuthenticationEffects.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ReAuthenticationEffects.ctorParameters = function () { return [
            { type: effects.Actions },
            { type: auth.AngularFireAuth }
        ]; };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ReAuthenticationEffects.prototype, "googleReAuthentication", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ReAuthenticationEffects.prototype, "facebookReAuthentication", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ReAuthenticationEffects.prototype, "reAuthenticateWithCredentials", void 0);
        return ReAuthenticationEffects;
    }());
    if (false) {
        /** @type {?} */
        ReAuthenticationEffects.prototype.googleReAuthentication;
        /** @type {?} */
        ReAuthenticationEffects.prototype.facebookReAuthentication;
        /** @type {?} */
        ReAuthenticationEffects.prototype.reAuthenticateWithCredentials;
        /**
         * @type {?}
         * @private
         */
        ReAuthenticationEffects.prototype.actions;
        /**
         * @type {?}
         * @private
         */
        ReAuthenticationEffects.prototype.afAuth;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var EmailAuthProvider = app.auth.EmailAuthProvider;
    var ProvidersManagementEffects = /** @class */ (function () {
        function ProvidersManagementEffects(actions$, afAuth) {
            var _this = this;
            this.actions$ = actions$;
            this.afAuth = afAuth;
            this.linkToGoogleAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.LinkGoogleAccount), operators.exhaustMap((/**
             * @param {?} actins
             * @return {?}
             */
            function (actins) {
                return rxjs.from(_this.doLinkToGoogleProvider()).pipe(operators.mapTo(new LinkSuccess({ provider: 'google' })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new LinkError(error)); })));
            })));
            this.linkToFacebookAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.LinkFacebookAccount), operators.exhaustMap((/**
             * @param {?} actions
             * @return {?}
             */
            function (actions) {
                return rxjs.from(_this.doLinkToFacebookProvider()).pipe(operators.mapTo(new LinkSuccess({ provider: 'facebook' })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new LinkError(error)); })));
            })));
            this.linkToCredentialsAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.LinkCredentialAccount), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.reAuthenticate().then((/**
                 * @param {?} res
                 * @return {?}
                 */
                function (res) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.doLinkToCredentials(this.afAuth.auth.currentUser.email, payload.password)];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); }))).pipe(operators.mapTo(new LinkSuccess({ provider: 'password' })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    if (error.code === 'auth/popup-blocked') {
                        return rxjs.from(_this.reAuthenticateWithRedirect().then((/**
                         * @param {?} res
                         * @return {?}
                         */
                        function (res) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.doLinkToCredentials(this.afAuth.auth.currentUser.email, payload.password)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); }))).pipe(operators.mapTo(new LinkSuccess({ provider: 'password' })), operators.catchError((/**
                         * @param {?} error1
                         * @return {?}
                         */
                        function (error1) { return rxjs.of(new LinkError(error1)); })));
                    }
                    else {
                        return rxjs.of(new LinkError(error));
                    }
                })));
            })));
            this.unlinkGoogleAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.UnlinkGoogleAccount), operators.exhaustMap((/**
             * @param {?} actions
             * @return {?}
             */
            function (actions) {
                return rxjs.from(_this.doUnlinkToGoogleProvider()).pipe(operators.mapTo(new UnlinkSuccess({ provider: 'google' })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new UnlinkError(error)); })));
            })));
            this.unlinkFacebookAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.UnlinkFacebookAccount), operators.exhaustMap((/**
             * @param {?} actions
             * @return {?}
             */
            function (actions) {
                return rxjs.from(_this.doUnlinkToFacebookProvider()).pipe(operators.mapTo(new UnlinkSuccess({ provider: 'facebook' })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new UnlinkError(error)); })));
            })));
            this.unlinkCredentialsAccount$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.UnlinkCredentialAccount), operators.exhaustMap((/**
             * @param {?} action
             * @return {?}
             */
            function (action) {
                return rxjs.from(_this.reAuthenticate().then((/**
                 * @param {?} res
                 * @return {?}
                 */
                function (res) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.doUnlinkToCredentials()];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); }))).pipe(operators.mapTo(new UnlinkSuccess({ provider: 'password' })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new UnlinkError(error)); })));
            })));
            this.unlinkPhone$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.UnlinkPhoneNumber), operators.exhaustMap((/**
             * @param {?} action
             * @return {?}
             */
            function (action) {
                return rxjs.from(_this.doUnlinkPhoneNumber()).pipe(operators.mapTo(new UnlinkSuccess({ provider: 'phone' })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new UnlinkError(error)); })));
            })));
            this.sendCodeToPhone$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.SendPhoneNumberCode), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(((/**
                 * @return {?}
                 */
                function () {
                    return _this.afAuth.auth.currentUser.linkWithPhoneNumber(payload.number, new app.auth.RecaptchaVerifier(payload.captchaContainerId, {
                        size: 'invisible',
                        callback: (/**
                         * @param {?} token
                         * @return {?}
                         */
                        function (token) {
                            console.debug('Captcha token', token);
                        })
                    })).then((/**
                     * @param {?} confirmation
                     * @return {?}
                     */
                    function (confirmation) {
                        _this.phoneNumberConfirmation = confirmation;
                    }));
                }))()).pipe(operators.mapTo(new CodeSent()), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new LinkError(error)); })));
            })));
            this.verifyCode$ = this.actions$.pipe(effects.ofType(ProvidersManagementActionTypes.VerifyPhoneNumber), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.phoneNumberConfirmation.confirm(payload.code)).pipe(operators.mapTo(new LinkSuccess({ provider: 'phone' })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new LinkError(error)); })));
            })));
        }
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doLinkToGoogleProvider = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.GoogleAuthProvider();
            return this.afAuth.auth.currentUser.linkWithPopup(provider);
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doUnlinkToGoogleProvider = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.GoogleAuthProvider();
            return this.afAuth.auth.currentUser.unlink(provider.providerId);
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doLinkToFacebookProvider = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.FacebookAuthProvider();
            return this.afAuth.auth.currentUser.linkWithPopup(provider);
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doUnlinkToFacebookProvider = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.FacebookAuthProvider();
            return this.afAuth.auth.currentUser.unlink(provider.providerId);
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doUnlinkPhoneNumber = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.PhoneAuthProvider();
            return this.afAuth.auth.currentUser.unlink(provider.providerId);
        };
        /**
         * @private
         * @param {?} email
         * @param {?} password
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doLinkToCredentials = /**
         * @private
         * @param {?} email
         * @param {?} password
         * @return {?}
         */
        function (email, password) {
            /** @type {?} */
            var credentials = EmailAuthProvider.credential(email, password);
            return this.afAuth.auth.currentUser.linkAndRetrieveDataWithCredential(credentials);
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doUnlinkToCredentials = /**
         * @private
         * @return {?}
         */
        function () {
            return this.afAuth.auth.currentUser.unlink(EmailAuthProvider.EMAIL_PASSWORD_SIGN_IN_METHOD);
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doFacebookReAuthentication = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.FacebookAuthProvider();
            return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doFacebookReAuthenticationWithRedirect = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.FacebookAuthProvider();
            return this.afAuth.auth.currentUser.reauthenticateWithRedirect(provider);
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.reAuthenticate = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            return this.afAuth.auth.fetchSignInMethodsForEmail(this.afAuth.auth.currentUser.email).then((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(res.indexOf('facebook.com') >= 0)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.doFacebookReAuthentication()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                        case 2: return [4 /*yield*/, this.doGoogleReAuthentication()];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); }));
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.reAuthenticateWithRedirect = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            return this.afAuth.auth.fetchSignInMethodsForEmail(this.afAuth.auth.currentUser.email).then((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(res.indexOf('facebook.com') >= 0)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.doFacebookReAuthenticationWithRedirect()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                        case 2: return [4 /*yield*/, this.doGoogleReAuthenticationWithRedirect()];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); }));
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doGoogleReAuthentication = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.GoogleAuthProvider();
            return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
        };
        /**
         * @private
         * @return {?}
         */
        ProvidersManagementEffects.prototype.doGoogleReAuthenticationWithRedirect = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var provider = new app.auth.GoogleAuthProvider();
            return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
        };
        ProvidersManagementEffects.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ProvidersManagementEffects.ctorParameters = function () { return [
            { type: effects.Actions },
            { type: auth.AngularFireAuth }
        ]; };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "linkToGoogleAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "linkToFacebookAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "linkToCredentialsAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "unlinkGoogleAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "unlinkFacebookAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "unlinkCredentialsAccount$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "unlinkPhone$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "sendCodeToPhone$", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], ProvidersManagementEffects.prototype, "verifyCode$", void 0);
        return ProvidersManagementEffects;
    }());
    if (false) {
        /** @type {?} */
        ProvidersManagementEffects.prototype.linkToGoogleAccount$;
        /** @type {?} */
        ProvidersManagementEffects.prototype.linkToFacebookAccount$;
        /** @type {?} */
        ProvidersManagementEffects.prototype.linkToCredentialsAccount$;
        /** @type {?} */
        ProvidersManagementEffects.prototype.unlinkGoogleAccount$;
        /** @type {?} */
        ProvidersManagementEffects.prototype.unlinkFacebookAccount$;
        /** @type {?} */
        ProvidersManagementEffects.prototype.unlinkCredentialsAccount$;
        /** @type {?} */
        ProvidersManagementEffects.prototype.unlinkPhone$;
        /** @type {?} */
        ProvidersManagementEffects.prototype.sendCodeToPhone$;
        /** @type {?} */
        ProvidersManagementEffects.prototype.verifyCode$;
        /**
         * @type {?}
         * @private
         */
        ProvidersManagementEffects.prototype.phoneNumberConfirmation;
        /**
         * @type {?}
         * @private
         */
        ProvidersManagementEffects.prototype.actions$;
        /**
         * @type {?}
         * @private
         */
        ProvidersManagementEffects.prototype.afAuth;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PasswordManagementEffects = /** @class */ (function () {
        function PasswordManagementEffects(actions$, afAuth) {
            var _this = this;
            this.actions$ = actions$;
            this.afAuth = afAuth;
            this.changePassword = this.actions$.pipe(effects.ofType(PasswordManagementActionTypes.ChangePasswordRequest), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                /** @type {?} */
                var credentials = app.auth.EmailAuthProvider.credential(_this.afAuth.auth.currentUser.email, payload.oldPassword);
                return rxjs.from(_this.afAuth.auth.currentUser.reauthenticateAndRetrieveDataWithCredential(credentials).then((/**
                 * @param {?} res
                 * @return {?}
                 */
                function (res) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.afAuth.auth.currentUser.updatePassword(payload.newPassword)];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); }))).pipe(operators.mapTo(new ChangePasswordSuccess()), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new ChangePasswordError(error)); })));
            })));
            this.passwordForgotten$ = this.actions$.pipe(effects.ofType(PasswordManagementActionTypes.ResetPasswordRequest), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.exhaustMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.afAuth.auth.sendPasswordResetEmail(payload.email, { url: payload.redirectUrl })).pipe(operators.map((/**
                 * @param {?} authData
                 * @return {?}
                 */
                function (authData) {
                    return new ResetPasswordRequestSuccess();
                })), operators.catchError((/**
                 * @param {?} err
                 * @return {?}
                 */
                function (err) { return rxjs.of(new ResetPasswordRequestError(err)); })));
            })));
        }
        PasswordManagementEffects.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        PasswordManagementEffects.ctorParameters = function () { return [
            { type: effects.Actions },
            { type: auth.AngularFireAuth }
        ]; };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], PasswordManagementEffects.prototype, "changePassword", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", Object)
        ], PasswordManagementEffects.prototype, "passwordForgotten$", void 0);
        return PasswordManagementEffects;
    }());
    if (false) {
        /** @type {?} */
        PasswordManagementEffects.prototype.changePassword;
        /** @type {?} */
        PasswordManagementEffects.prototype.passwordForgotten$;
        /**
         * @type {?}
         * @private
         */
        PasswordManagementEffects.prototype.actions$;
        /**
         * @type {?}
         * @private
         */
        PasswordManagementEffects.prototype.afAuth;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomEmailHandlerEffects = /** @class */ (function () {
        function CustomEmailHandlerEffects(actions$, afAuth) {
            var _this = this;
            this.actions$ = actions$;
            this.afAuth = afAuth;
            this.verifyEmail = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.VerifyEmailAddress), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.switchMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.afAuth.auth.applyActionCode(payload.actionCode).then((/**
                 * @param {?} res
                 * @return {?}
                 */
                function (res) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        return [2 /*return*/];
                    });
                }); }))).pipe(operators.mapTo(new VerifyEmailAddressSuccess()), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new VerifyEmailAddressError(error)); })));
            })));
            this.verifyPasswordResetCode = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.VerifyPasswordResetCode), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.switchMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.afAuth.auth.verifyPasswordResetCode(payload.actionCode)).pipe(operators.switchMap((/**
                 * @param {?} email
                 * @return {?}
                 */
                function (email) {
                    return rxjs.of(new VerifyPasswordResetCodeSuccess({ email: email, actionCode: payload.actionCode }));
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new VerifyPasswordResetCodeError(error)); })));
            })));
            this.resetPassword = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.ResetPassword), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.switchMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.afAuth.auth.confirmPasswordReset(payload.actionCode, payload.newPassword)).pipe(operators.switchMap((/**
                 * @return {?}
                 */
                function () {
                    return rxjs.of(new ResetPasswordSuccess());
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new ResetPasswordError(error)); })));
            })));
            this.checkActionCode = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.CheckActionCode), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.switchMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.afAuth.auth.checkActionCode(payload.actionCode)).pipe(operators.map((/**
                 * @param {?} info
                 * @return {?}
                 */
                function (info) { return info['data']['email']; })), operators.switchMap((/**
                 * @param {?} restoredEmail
                 * @return {?}
                 */
                function (restoredEmail) {
                    return rxjs.of(new CheckActionCodeSuccess({ actionCode: payload.actionCode, restoredEmail: restoredEmail }));
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new CheckActionCodeError(error)); })));
            })));
            this.revertOldEmail = this.actions$.pipe(effects.ofType(CustomEmailHandlerActionTypes.RecoverEmail), operators.map((/**
             * @param {?} action
             * @return {?}
             */
            function (action) { return action.payload; })), operators.switchMap((/**
             * @param {?} payload
             * @return {?}
             */
            function (payload) {
                return rxjs.from(_this.afAuth.auth.applyActionCode(payload.actionCode)).pipe(operators.switchMap((/**
                 * @return {?}
                 */
                function () {
                    return rxjs.of(new RecoverEmailSuccess());
                })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.of(new RecoverEmailError(error)); })));
            })));
        }
        CustomEmailHandlerEffects.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        CustomEmailHandlerEffects.ctorParameters = function () { return [
            { type: effects.Actions },
            { type: auth.AngularFireAuth }
        ]; };
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "verifyEmail", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "verifyPasswordResetCode", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "resetPassword", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "checkActionCode", void 0);
        __decorate([
            effects.Effect(),
            __metadata("design:type", rxjs.Observable)
        ], CustomEmailHandlerEffects.prototype, "revertOldEmail", void 0);
        return CustomEmailHandlerEffects;
    }());
    if (false) {
        /** @type {?} */
        CustomEmailHandlerEffects.prototype.verifyEmail;
        /** @type {?} */
        CustomEmailHandlerEffects.prototype.verifyPasswordResetCode;
        /** @type {?} */
        CustomEmailHandlerEffects.prototype.resetPassword;
        /** @type {?} */
        CustomEmailHandlerEffects.prototype.checkActionCode;
        /** @type {?} */
        CustomEmailHandlerEffects.prototype.revertOldEmail;
        /**
         * @type {?}
         * @private
         */
        CustomEmailHandlerEffects.prototype.actions$;
        /**
         * @type {?}
         * @private
         */
        CustomEmailHandlerEffects.prototype.afAuth;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FirebaseNgrxUserManagementModule = /** @class */ (function () {
        function FirebaseNgrxUserManagementModule() {
        }
        FirebaseNgrxUserManagementModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            fire.AngularFireModule,
                            auth.AngularFireAuthModule,
                            effects.EffectsModule.forFeature([
                                CustomEmailHandlerEffects,
                                LoginEffects,
                                ReAuthenticationEffects,
                                RegistrationEffects,
                                ProvidersManagementEffects,
                                PasswordManagementEffects
                            ]),
                            store.StoreModule.forFeature('auth', reducers)
                        ],
                        declarations: [],
                        exports: [],
                        providers: []
                    },] }
        ];
        return FirebaseNgrxUserManagementModule;
    }());

    exports.AuthActions = auth_actions;
    exports.CustomEmailHandlerActions = customEmailHandler_actions;
    exports.FirebaseNgrxUserManagementModule = FirebaseNgrxUserManagementModule;
    exports.FirebaseNgrxUserManagementService = FirebaseNgrxUserManagementService;
    exports.PasswordManagementActions = passwordManagement_actions;
    exports.ProvidersManagementActions = providersManagement_actions;
    exports.User = User;
    exports.getAuthError = getAuthError;
    exports.getAuthState = getAuthState;
    exports.getChangePasswordStatus = getChangePasswordStatus;
    exports.getCheckCodeError = getCheckCodeError;
    exports.getCustomEmailHandlerRequestStatus = getCustomEmailHandlerRequestStatus;
    exports.getEmailVerifiedError = getEmailVerifiedError;
    exports.getEmailVerifiedStatus = getEmailVerifiedStatus;
    exports.getPasswordResetCodeEmail = getPasswordResetCodeEmail;
    exports.getPasswordResetCodeError = getPasswordResetCodeError;
    exports.getPasswordResetStatus = getPasswordResetStatus;
    exports.getProvidersRequestStatus = getProvidersRequestStatus;
    exports.getRecoverEmailError = getRecoverEmailError;
    exports.getRecoverEmailOrCheckCodeError = getRecoverEmailOrCheckCodeError;
    exports.getResetPasswordError = getResetPasswordError;
    exports.getResetPasswordOrCodeError = getResetPasswordOrCodeError;
    exports.getResetPasswordSuccess = getResetPasswordSuccess;
    exports.getUser = getUser;
    exports.getUserProviders = getUserProviders;
    exports.getUserProvidersState = getUserProvidersState;
    exports.getUserState = getUserState;
    exports.getVerifyResetPasswordProcedure = getVerifyResetPasswordProcedure;
    exports.isAuthLoading = isAuthLoading;
    exports.isAuthSuccess = isAuthSuccess;
    exports.isCheckCodeLoading = isCheckCodeLoading;
    exports.isEmailVerifiedLoading = isEmailVerifiedLoading;
    exports.isPasswordResetCodeLoading = isPasswordResetCodeLoading;
    exports.isRecoverEmailLoading = isRecoverEmailLoading;
    exports.isRecoverEmailOrCheckCodeLoading = isRecoverEmailOrCheckCodeLoading;
    exports.isResetPasswordLoading = isResetPasswordLoading;
    exports.isResetPasswordOrCodeLoading = isResetPasswordOrCodeLoading;
    exports.isUserLogged = isUserLogged;
    exports.ɵa = reducers;
    exports.ɵb = reducer;
    exports.ɵc = reducer$2;
    exports.ɵd = CustomEmailHandlerEffects;
    exports.ɵe = LoginEffects;
    exports.ɵf = ReAuthenticationEffects;
    exports.ɵg = RegistrationEffects;
    exports.ɵh = ProvidersManagementEffects;
    exports.ɵi = PasswordManagementEffects;
    exports.ɵj = reducer$1;
    exports.ɵk = reducer$3;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=xtream-firebase-ngrx-user-management.umd.js.map
