import { Actions } from '@ngrx/effects';
import { AngularFireAuth } from '@angular/fire/auth';
import { Observable } from 'rxjs';
import { Action } from '@ngrx/store';
import * as customEmailHandlerActions from '../actions/custom-email-handler.actions';
export declare type Action = customEmailHandlerActions.CustomEmailHandlerActionsUnion;
export declare class CustomEmailHandlerEffects {
    private actions$;
    private afAuth;
    verifyEmail: Observable<Action>;
    verifyPasswordResetCode: Observable<Action>;
    resetPassword: Observable<Action>;
    checkActionCode: Observable<Action>;
    revertOldEmail: Observable<Action>;
    constructor(actions$: Actions, afAuth: AngularFireAuth);
}
