import { Actions } from '@ngrx/effects';
import { AngularFireAuth } from '@angular/fire/auth';
import * as userActions from '../actions/auth.actions';
import { Observable } from 'rxjs';
import 'firebase/auth';
import { Action } from '@ngrx/store';
import { GooglePlus } from '@ionic-native/google-plus/ngx';
import { Facebook } from '@ionic-native/facebook/ngx';
import { Platform } from '@ionic/angular';
import { FirebaseUserManagementConfig } from '../config';
export declare class LoginEffects {
    private actions$;
    private afAuth;
    private fb;
    private gplus;
    private platform;
    private config;
    getUser: Observable<Action>;
    googleLogin: Observable<Action>;
    facebookLogin: Observable<Action>;
    loginWithCredentials: Observable<Action>;
    logout: Observable<Action>;
    refreshToken$: Observable<userActions.GetUser>;
    private doFacebookLogin;
    private doFacebookLoginMobile;
    private doGoogleLogin;
    private doGoogleLoginMobile;
    private doLoginWithCredentials;
    constructor(actions$: Actions, afAuth: AngularFireAuth, fb: Facebook, gplus: GooglePlus, platform: Platform, config: FirebaseUserManagementConfig);
}
