import { Actions } from '@ngrx/effects';
import { AngularFireAuth } from '@angular/fire/auth';
import { Observable } from 'rxjs';
import 'firebase/auth';
import { Action } from '@ngrx/store';
export declare class LoginEffects {
    private actions$;
    private afAuth;
    getUser: Observable<Action>;
    googleLogin: Observable<Action>;
    facebookLogin: Observable<Action>;
    loginWithCredentials: Observable<Action>;
    logout: Observable<Action>;
    onDeleteNotVerifiedAccount$: Observable<any>;
    refreshToken$: Observable<never>;
    constructor(actions$: Actions, afAuth: AngularFireAuth);
    private doFacebookLogin;
    private doGoogleLogin;
    private doLoginWithCredentials;
}
