import { Actions } from '@ngrx/effects';
import { AngularFireAuth } from '@angular/fire/auth';
import * as userActions from '../actions/auth.actions';
import { Observable } from 'rxjs';
import 'firebase/auth';
export declare type Action = userActions.AuthActionsUnion;
export declare class ReAuthenticationEffects {
    private actions;
    private afAuth;
    constructor(actions: Actions, afAuth: AngularFireAuth);
    googleReAuthentication: Observable<Action>;
    facebookReAuthentication: Observable<Action>;
    reAuthenticateWithCredentials: Observable<Action>;
    private doFacebookReAuthentication;
    private doGoogleReAuthentication;
    private doReAuthenticationWithCredentials;
}
