import { Actions } from '@ngrx/effects';
import { AngularFireAuth } from '@angular/fire/auth';
import { AuthActions } from '../actions';
import { Observable } from 'rxjs';
import 'firebase/auth';
import { ProvidersManagementActionsUnion } from '../actions/providers-management.actions';
export declare type Action = AuthActions.AuthActionsUnion | ProvidersManagementActionsUnion;
export declare class RegistrationEffects {
    private actions;
    private afAuth;
    constructor(actions: Actions, afAuth: AngularFireAuth);
    googleSignUp: Observable<Action>;
    facebookSignUp: Observable<Action>;
    signUpWithCredentials: Observable<Action>;
    sendVerificationEmail$: Observable<Action>;
    private doFacebookRegistration;
    private doGoogleRegistration;
    private doSignUpWithCredentials;
}
