import { CustomEmailHandlerActionsUnion } from '../actions/custom-email-handler.actions';
export interface State {
    emailVerified: {
        loading: boolean;
        success: boolean;
        error: {
            code: string;
            message: string;
        };
    };
    passwordResetCode: {
        email: string;
        loading: boolean;
        success: boolean;
        error: {
            code: string;
            message: string;
        };
    };
    resetPassword: {
        loading: boolean;
        success: boolean;
        error: {
            code: string;
            message: string;
        };
    };
    checkCode: {
        loading: boolean;
        success: boolean;
        error: {
            code: string;
            message: string;
        };
    };
    recoverEmail: {
        loading: boolean;
        success: boolean;
        error: {
            code: string;
            message: string;
        };
    };
}
export declare function reducer(state: State, action: CustomEmailHandlerActionsUnion): State;
